/*
  E = T
    | T [+|-] E
  T = P
    | P [*|/] T
  P = NUMBER
    | ( E )
*/
long E(void), T(void), P(void);

int nxt_ch;

#define to_num(x) (x-'0')

int is_num(int ch)
{
  return (ch>='0')&&(ch<='9');
}

int is_white(int ch)
{
  return (ch==' ')||(ch=='\t');
}

void skip_white(void)
{
  while(is_white(nxt_ch))
    nxt_ch = getchar();
}

long P(void)
{
  long v;
  int  s;
  nxt_ch = getchar();
  skip_white();
  if(nxt_ch=='-'){
    s = 1;
    nxt_ch = getchar();
  }
  else
    s = 0;
  skip_white();
  if(is_num(nxt_ch)){
    v = to_num(nxt_ch);
    while(is_num(nxt_ch=getchar()))
      v = v*10 + to_num(nxt_ch);
  }
  else if(nxt_ch=='('){
    v = E();
    skip_white();
    if(nxt_ch!=')')
      printf("missing )!\n");
    nxt_ch = getchar();
  }
  else{
    exit(0);
  }
  return (s)? -v : v;
}

long T(void)
{
  long v1,v2;
  int  op;
  v1 = P();
  skip_white();
  op = nxt_ch;
  if((op!='*')&&(op!='/')){
    return v1;
  }
  v2 = T();
  return (op=='*')? v1*v2 : v1/v2;
}

long E(void)
{
  long v1,v2;
  int  op;
  v1 = T();
  skip_white();
  op = nxt_ch;
  if((op!='+')&&(op!='-')){
    return v1;
  }
  v2 = E();
  return (op=='+')? v1+v2 : v1-v2;
}

main()
{
  while(1){
    printf("->");
    printf("= %d\n", E());
  }
  exit(0);
}





