/*************************************************/
/* All rights reserved by Akira Nakamori. This   */
/* program must be uesed solely for the purpose  */ 
/* for which it was furnished by Akira Nakamori. */
/*                                               */
/*     Copyright (C) Akira Nakamori 2004         */
/*************************************************/
#include <stdio.h>
#include "define.h"

extern int watch_pend;
extern int ty_cpu;
extern int fpu_en;
extern int addr64;
extern int mips32_en;

static struct {
  ulong mask;
  uint  r;
  ulong vpn2;
  uint  g;
  uint  asid;
  ulong pfn0;
  uint  c0;
  uint  d0;
  uint  v0;
  ulong pfn1;
  uint  c1;
  uint  d1;
  uint  v1;
} TLB[48];

static ulong lastpa;
static ulong PageMask;
static ulong EntryHi_H;
static ulong EntryHi_L;
static ulong EntryLo0;
static ulong EntryLo1;
static ulong Index;
static ulong Random;
static ulong Wired;
static ulong PRId;
static ulong Config;
static ulong Config0=(1<<31)|(0<<15)|(2<<13)|(0<<10)|(1<<7);
static ulong Config1=(1<<31)|((NTLB-1)<<25)|(CFG_IS<<22)|(CFG_IL<<19)|(CFG_IA<<16)|(CFG_DS<<13)|(CFG_DL<<10)|(CFG_DA<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<3)|(1<<2)|(0<<1)|(1<<0);
static ulong Config2=(1<<31);
static ulong Config3=(0<<31)|(0<<1)|(0<<0);
static ulong LLAddr;
static ulong Context;
static ulong Context_H;
static ulong BadVAddr_H;
static ulong BadVAddr_L;
static ulong Count;
static ulong Compare;
static ulong Status;
static ulong Cause;
static ulong EPC_H;
static ulong EPC_L;
static ulong WatchLo;
static ulong WatchHi;
static ulong XContext_H;
static ulong XContext_L;
static ulong PErr;
static ulong CacheErr;
static ulong ErrorEPC_H;
static ulong ErrorEPC_L;
static ulong TagLo;
static ulong TagHi;

void set_badva(ulong hi, ulong lo)
{
  BadVAddr_H = hi;
  BadVAddr_L = lo;
}

ulong get_cause(void)
{
  if(mips32_en)
    return Cause | (watch_pend<<22);
  return Cause;
}

void set_cause(ulong v)
{
  Cause = v;
}

ulong get_context(void)
{
  return Context;
}

void set_context(ulong v)
{
  Context = v;
}

void get_xcontext(ulong *hi, ulong *lo)
{
  *hi = XContext_H;
  *lo = XContext_L;
}

void set_xcontext(ulong hi, ulong lo)
{
  XContext_H = hi;
  XContext_H = lo;
}

void mtc0(int regno, ulong value)
{
  switch(regno&0x1f){
  case C0_Index:
    if(ty_cpu==R4300){
      Index = value & 0x8000003fL;
    }
    if(ty_cpu==R4100){
      Index = value & 0x8000001fL;
    }
    break;
  case C0_Random:
    if(ty_cpu==R4300){
      Random = value & 0x0000003fL;
    }
    if(ty_cpu==R4100){
      Random = value & 0x0000001fL;
    }
    break;
  case C0_EntryLo0:
    if(ty_cpu==R4300){
      EntryLo0 = value & 0x07ffffffL;
    }
    if(ty_cpu==R4100){
      EntryLo0 = value & 0x0fffffffL;
    }
    break;
  case C0_EntryLo1:
    if(ty_cpu==R4300){
      EntryLo1 = value & 0x07ffffffL;
    }
    if(ty_cpu==R4100){
      EntryLo1 = value & 0x0fffffffL;
    }
    break;
  case C0_Context:
    if(ty_cpu==R4300){
      Context = (value & 0xff800000L)|(Context & 0x007fffffL);
    }
    if(ty_cpu==R4100){
      Context = (value & 0xff000000L)|(Context & 0x00ffffffL);
    }
    if(ty_cpu==R4300){
      XContext_L = (value & 0xff800000L)|(Context & 0x007fffffL);
    }
    if(ty_cpu==R4100){
      XContext_L = (value & 0xff000000L)|(Context & 0x00ffffffL);
    }
    break;
  case C0_PageMask:
    if(ty_cpu==R4300){
      PageMask = value & (ulong)(0xfff<<13);
    }
    if(ty_cpu==R4100){
      PageMask = value & (ulong)(0xff<<11);
    }
    break;
  case C0_Wired:
    if(ty_cpu==R4300){
      Wired = value & 0x0000003fL;
      Random = 0x3fL;
    }
    if(ty_cpu==R4100){
      Wired = value & 0x0000001fL;
      Random = 0x1fL;
    }
    break;
  case C0_BadVAddr:
/*
    BadVAddr_L = value;
    BadVAddr_H = sign_extend(BadVAddr_L);
*/
    break;
  case C0_Count:
    Count = value;
    break;
  case C0_EntryHi:
    if(ty_cpu==R4300){
      EntryHi_L = value & 0xffffe0ffL;
    }
    if(ty_cpu==R4100){
      EntryHi_L = value & 0xfffff8ffL;
    }
    EntryHi_H = sign_extend(EntryHi_L);
    break;
  case C0_Compare:
    Compare = value;
    Cause  &= 0xbfff7fffL;
    break;
  case C0_SR:
    Status = value & 0xbfffffffL;
    if(!fpu_en)
      Status &= 0xdfffffffL;
    break;
  case C0_Cause:
    if(mips32_en)
      Cause = (value & 0x08c00300L)|(Cause & 0xf73ffcffL);
    else
      Cause = (value & 0x00000300L)|(Cause & 0xfffffcffL);
    break;
  case C0_EPC:
    EPC_L = value;
    EPC_H = sign_extend(EPC_L);
    break;
  case C0_PRId:
    break;
  case C0_Config:
    if(mips32_en){
      if(((regno>>5)&7)==0)
        Config0 = (Config0&0xfffffff0L) | (value&0xfL);
    }
    else
      Config = (Config&0xfffffff0L) | (value&0xfL);
    break;
  case C0_LLAddr:
    LLAddr = value;
    break;
  case C0_WatchLo:
    WatchLo = value;
    break;
  case C0_WatchHi:
    break;
  case C0_XContext:
    if(ty_cpu==R4300){
      Context = (value & 0xff800000L)|(Context & 0x007fffffL);
    }
    if(ty_cpu==R4100){
      Context = (value & 0xff000000L)|(Context & 0x00ffffffL);
    }
    if(ty_cpu==R4300){
      XContext_L = (value & 0xff800000L)|(Context & 0x007fffffL);
    }
    if(ty_cpu==R4100){
      XContext_L = (value & 0xff000000L)|(Context & 0x00ffffffL);
    }
    break;
  case C0_PErr:
    PErr = value & 0xffL;
    break;
  case C0_CacheErr:
    break;
  case C0_TagLo:
    if(ty_cpu==R4300){
      TagLo = value & 0x0fffffc0L;
    }
    if(ty_cpu==R4100){
      TagLo = value & 0xffffff80L;
    }
    break;
  case C0_TagHi:
    break;
  case C0_ErrorEPC:
    ErrorEPC_L = value;
    ErrorEPC_H = sign_extend(ErrorEPC_L);
    break;
  }
}

ulong mfc0(int regno)
{
  switch(regno&0x1f){
  case C0_Index:
    return Index;
  case C0_Random:
    return Random;
  case C0_EntryLo0:
    return EntryLo0;
  case C0_EntryLo1:
    return EntryLo1;
  case C0_Context:
    if(ty_cpu==R4300)
      return (Context&0xff800000L)|
             ((BadVAddr_L>>(13-4))&0x007ffff0L);
    else
      return (Context&0xfe000000L)|
             ((BadVAddr_L>>(11-4))&0x01fffff0L);
  case C0_PageMask:
    return PageMask;
  case C0_Wired:
    return Wired;
  case C0_BadVAddr:
    return BadVAddr_L;
  case C0_Count:
    return Count;
  case C0_EntryHi:
    return EntryHi_L;
  case C0_Compare:
    return Compare;
  case C0_SR:
    return Status;
  case C0_Cause:
    if(mips32_en)
      return Cause | (watch_pend<<22);
    return Cause;
  case C0_EPC:
    return EPC_L;
  case C0_PRId:
    if(ty_cpu==R4300)
      return 0x00000b00L;
    else
      return 0x00000c00L;
  case C0_Config:
    if(mips32_en){
      switch((regno>>5)&7){
      case 1:
        return Config1;
      case 2:
        return Config2;
      case 3:
        return Config3;
      default:
        return Config0;
      }
    }
    else
      return Config;
  case C0_LLAddr:
    return LLAddr;
  case C0_WatchLo:
    return WatchLo;
  case C0_WatchHi:
    return 0L;
  case C0_XContext:
    if(ty_cpu==R4300)
      return (BadVAddr_H<<31)|
             ((BadVAddr_H<<23)&0x7f800000L)|
             ((BadVAddr_L>>(13-4))&0x007ffff0L);
    else
      return ((BadVAddr_H<<25)&0xfe000000L)|
             ((BadVAddr_L>>(11-4))&0x01fffff0L);
  case C0_PErr:
    return PErr;
  case C0_CacheErr:
    return 0L;
  case C0_TagLo:
    return TagLo;
  case C0_TagHi:
    return 0L;
  case C0_ErrorEPC:
    return ErrorEPC_L;
  default:
	return 0L;
  }
}

void dmtc0(int regno, ulong hi, ulong lo)
{
  switch(regno&0x1f){
  case C0_Index:
    if(ty_cpu==R4300){
      Index = lo & 0x8000003fL;
    }
    if(ty_cpu==R4100){
      Index = lo & 0x8000001fL;
    }
    break;
  case C0_Random:
    if(ty_cpu==R4300){
      Random = lo & 0x0000003fL;
    }
    if(ty_cpu==R4100){
      Random = lo & 0x0000001fL;
    }
    break;
  case C0_EntryLo0:
    if(ty_cpu==R4300){
      EntryLo0 = lo & 0x07ffffffL;
    }
    if(ty_cpu==R4100){
      EntryLo0 = lo & 0x0fffffffL;
    }
    break;
  case C0_EntryLo1:
    if(ty_cpu==R4300){
      EntryLo1 = lo & 0x07ffffffL;
    }
    if(ty_cpu==R4100){
      EntryLo1 = lo & 0x0fffffffL;
    }
    break;
  case C0_Context:
    if(ty_cpu==R4300){
      Context = (lo & 0xff800000L)|(Context & 0x007fffffL);
      Context_H = hi;
    }
    if(ty_cpu==R4100){
      Context = (lo & 0xff000000L)|(Context & 0x00ffffffL);
      Context_H = hi;
    }
    XContext_L = 0L;
    if(ty_cpu==R4300)
      XContext_H = hi&0xfffffffeL;
    else
      XContext_H = hi&0xfffffff8L;
    break;
    break;
  case C0_PageMask:
    if(ty_cpu==R4300){
      PageMask = lo & (ulong)(0xfff<<13);
    }
    if(ty_cpu==R4100){
      PageMask = lo & (ulong)(0xff<<11);
    }
    break;
  case C0_Wired:
    if(ty_cpu==R4300){
      Wired = lo & 0x0000003fL;
      Random = 0x3fL;
    }
    if(ty_cpu==R4100){
      Wired = lo & 0x0000001fL;
      Random = 0x1fL;
    }
    break;
  case C0_BadVAddr:
/*
    BadVAddr_L = lo;
    BadVAddr_H = hi;
*/
    break;
  case C0_Count:
    Count = lo;
    break;
  case C0_EntryHi:
    if(ty_cpu==R4300){
      EntryHi_L = lo & 0xffffe0ffL;
    }
    if(ty_cpu==R4100){
      EntryHi_L = lo & 0xfffff8ffL;
    }
    EntryHi_H = hi;
    break;
  case C0_Compare:
    Compare = lo;
    Cause  &= 0xbfff7fffL;
    break;
  case C0_SR:
    Status = lo & 0xbfffffffL;
    if(!fpu_en)
      Status &= 0xdfffffffL;
    break;
  case C0_Cause:
    if(mips32_en)
      Cause = (lo & 0x08c00300L)|(Cause & 0xf73ffcffL);
    else
      Cause = (lo & 0x00000300L)|(Cause & 0xfffffcffL);
    break;
  case C0_EPC:
    EPC_L = lo;
    EPC_H = hi;
    break;
  case C0_PRId:
    break;
  case C0_Config:
    if(mips32_en){
      if(((regno>>5)&7)==0)
        Config0 = (Config0&0xfffffff0L) | (lo&0xfL);
    }
    else
      Config = (Config&0xfffffff0L)|(lo&0xfL);
    break;
  case C0_LLAddr:
    LLAddr = lo;
    break;
  case C0_WatchLo:
    WatchLo = lo;
    break;
  case C0_WatchHi:
    break;
  case C0_XContext:
    XContext_L = 0L;
    if(ty_cpu==R4300)
      XContext_H = hi&0xfffffffeL;
    else
      XContext_H = hi&0xfffffff8L;
    if(ty_cpu==R4300){
      Context = (lo & 0xff800000L)|(Context & 0x007fffffL);
      Context_H = hi;
    }
    if(ty_cpu==R4100){
      Context = (lo & 0xff000000L)|(Context & 0x00ffffffL);
      Context_H = hi;
    }
    break;
  case C0_PErr:
    PErr = lo & 0xffL;
    break;
  case C0_CacheErr:
    break;
  case C0_TagLo:
    if(ty_cpu==R4300){
      TagLo = lo & 0x0fffffc0L;
    }
    if(ty_cpu==R4100){
      TagLo = lo & 0xffffff80L;
    }
    break;
  case C0_TagHi:
    break;
  case C0_ErrorEPC:
    ErrorEPC_L = lo;
    ErrorEPC_H = hi;
    break;
  }
}

void dmfc0(int regno, ulong *hi, ulong *lo)
{
  switch(regno&0x1f){
  case C0_Index:
    *lo = Index;
    *hi = sign_extend(Index);
    break;
  case C0_Random:
    *lo = Random;
    *hi = 0L;
    break;
  case C0_EntryLo0:
    *lo = EntryLo0;
    *hi = sign_extend(EntryLo0);
    break;
  case C0_EntryLo1:
    *lo = EntryLo1;
    *hi = sign_extend(EntryLo1);
    break;
  case C0_Context:
    if(ty_cpu==R4300)
      *lo = (Context&0xff800000L)|
            ((BadVAddr_L>>(13-4))&0x007ffff0L);
    else
      *lo = (Context&0xfe000000L)|
            ((BadVAddr_L>>(11-4))&0x01fffff0L);
    *hi = Context_H;
    break;
  case C0_PageMask:
    *lo = PageMask;
    *hi = 0L;
    break;
  case C0_Wired:
    *lo = Wired;
    *hi = 0L;
    break;
  case C0_BadVAddr:
    *lo = BadVAddr_L;
    *hi = BadVAddr_H;
    break;
  case C0_Count:
    *lo = Count;
    *hi = sign_extend(Count);
    break;
  case C0_EntryHi:
    *lo = EntryHi_L;
    *hi = (EntryHi_H&0xc00000ffL);
    break;
  case C0_Compare:
    *lo = Compare;
    *hi = sign_extend(Compare);
    break;
  case C0_SR:
    *lo = Status;
    *hi = sign_extend(Status);
    break;
  case C0_Cause:
    if(mips32_en)
      *lo = Cause | (watch_pend<<22);
    else
      *lo = Cause;
    *hi = sign_extend(Cause);
    break;
  case C0_EPC:
    *lo = EPC_L;
    *hi = EPC_H;
    break;
  case C0_PRId:
    if(ty_cpu==R4300)
      *lo = 0x00000b00L;
    else
      *lo = 0x00000c00L;
    *hi = 0L;
    break;
  case C0_Config:
    if(mips32_en){
      switch((regno>>5)&7){
      case 1:
        *lo = Config1;
        *hi = sign_extend(Config1);
        break;
      case 2:
        *lo = Config2;
        *hi = sign_extend(Config2);
        break;
      case 3:
        *lo = Config3;
        *hi = sign_extend(Config3);
        break;
      default:
        *lo = Config0;
        *hi = sign_extend(Config0);
        break;
      }
    }
    else{
      *lo = Config;
      *hi = sign_extend(Config);
    }
    break;
  case C0_LLAddr:
    *lo = LLAddr;
    *hi = sign_extend(LLAddr);
    break;
  case C0_WatchLo:
    *lo = WatchLo;
    *hi = sign_extend(WatchLo);
    break;
  case C0_WatchHi:
    *lo = 0L;
    *hi = 0L;
    break;
  case C0_XContext:
    if(ty_cpu==R4300){
      *lo = (BadVAddr_H<<31)|
            ((BadVAddr_H<<23)&0x7f800000L)|
            ((BadVAddr_L>>(13-4))&0x007ffff0L);
      *hi = XContext_H|((BadVAddr_H>>31)&1L);
    }
    else{
      *lo = ((BadVAddr_H<<25)&0xfe000000L)|
            ((BadVAddr_L>>(11-4))&0x01fffff0L);
      *hi = XContext_H|((BadVAddr_H>>29)&0x6L)|((BadVAddr_H>>7)&1L);
    }
    break;
  case C0_PErr:
    *lo = PErr;
    *hi = 0L;
    break;
  case C0_CacheErr:
    *lo = 0L;
    *hi = 0L;
    break;
  case C0_TagLo:
    *lo = TagLo;
    *hi = sign_extend(TagLo);
    break;
  case C0_TagHi:
    *lo = 0L;
    *hi = 0L;
    break;
  case C0_ErrorEPC:
    *lo = ErrorEPC_L;
    *hi = ErrorEPC_H;
    break;
  }
}

void tlbwi(void)
{
  int  index;

  if(ty_cpu==R4300){
    index = Index & 0x3fL;
    TLB[index].mask = (PageMask>>13)&0xfffL;
    TLB[index].asid = EntryHi_L & 0xffL;
    TLB[index].vpn2 = ((EntryHi_H<<19)|(EntryHi_L>>13))&0x07ffffffL;
    TLB[index].r    = (EntryHi_H>>30)&3L;
    TLB[index].g    = (EntryLo0&EntryLo1)&1L;
    TLB[index].pfn0 = (EntryLo0>>6);
    TLB[index].c0   = (EntryLo0>>3)&0x7L;
    TLB[index].d0   = (EntryLo0>>2)&1L;
    TLB[index].v0   = (EntryLo0>>1)&1L;
    TLB[index].pfn1 = (EntryLo1>>6);
    TLB[index].c1   = (EntryLo1>>3)&0x7L;
    TLB[index].d1   = (EntryLo1>>2)&1L;
    TLB[index].v1   = (EntryLo1>>1)&1L;
  }
  else{
    index = Index & 0x1fL;
    TLB[index].mask = (PageMask>>11)&0xffL;
    TLB[index].asid = EntryHi_L & 0xffL;
    TLB[index].vpn2 = ((EntryHi_H<<21)|(EntryHi_L>>11))&0x1fffffffL;
    TLB[index].r    = (EntryHi_H>>30)&3L;
    TLB[index].g    = (EntryLo0&EntryLo1)&1L;
    TLB[index].pfn0 = (EntryLo0>>6);
    TLB[index].c0   = (EntryLo0>>3)&0x7L;
    TLB[index].d0   = (EntryLo0>>2)&1L;
    TLB[index].v0   = (EntryLo0>>1)&1L;
    TLB[index].pfn1 = (EntryLo1>>6);
    TLB[index].c1   = (EntryLo1>>3)&0x7L;
    TLB[index].d1   = (EntryLo1>>2)&1L;
    TLB[index].v1   = (EntryLo1>>1)&1L;
  }
#if 0
printf("i=%d mask=%x asid=%x vpn2=%x r=%x g=%d pfn0=%x c0=%d d0=%d v0=%d pfn1=%x c1=%d d1=%d v1=%d\n",
index,
TLB[index].mask,
TLB[index].asid,
TLB[index].vpn2,
TLB[index].r,
TLB[index].g,
TLB[index].pfn0,
TLB[index].c0,
TLB[index].d0,
TLB[index].v0,
TLB[index].pfn1,
TLB[index].c1,
TLB[index].d1,
TLB[index].v1); 
#endif
}

void tlbwr(void)
{
  int  index;

  if(ty_cpu==R4300){
    index = Random & 0x3fL;
    TLB[index].mask = (PageMask>>13)&0xfffL;
    TLB[index].asid = EntryHi_L & 0xffL;
    TLB[index].vpn2 = ((EntryHi_H<<19)|(EntryHi_L>>13))&0x07ffffffL;
    TLB[index].r    = (EntryHi_H>>30)&3L;
    TLB[index].g    = (EntryLo0&EntryLo1)&1L;
    TLB[index].pfn0 = (EntryLo0>>6);
    TLB[index].c0   = (EntryLo0>>3)&0x7L;
    TLB[index].d0   = (EntryLo0>>2)&1L;
    TLB[index].v0   = (EntryLo0>>1)&1L;
    TLB[index].pfn1 = (EntryLo1>>6);
    TLB[index].c1   = (EntryLo1>>3)&0x7L;
    TLB[index].d1   = (EntryLo1>>2)&1L;
    TLB[index].v1   = (EntryLo1>>1)&1L;
  }
  else{
    index = Random & 0x1fL;
    TLB[index].mask = (PageMask>>11)&0xffL;
    TLB[index].asid = EntryHi_L & 0xffL;
    TLB[index].vpn2 = ((EntryHi_H<<21)|(EntryHi_L>>11))&0x1fffffffL;
    TLB[index].r    = (EntryHi_H>>30)&3L;
    TLB[index].g    = (EntryLo0&EntryLo1)&1L;
    TLB[index].pfn0 = (EntryLo0>>6);
    TLB[index].c0   = (EntryLo0>>3)&0x7L;
    TLB[index].d0   = (EntryLo0>>2)&1L;
    TLB[index].v0   = (EntryLo0>>1)&1L;
    TLB[index].pfn1 = (EntryLo1>>6);
    TLB[index].c1   = (EntryLo1>>3)&0x7L;
    TLB[index].d1   = (EntryLo1>>2)&1L;
    TLB[index].v1   = (EntryLo1>>1)&1L;
  }
}

ulong va2pa(ulong va_hi, ulong va_lo, int *c, int *d, int *v, int *hit)
{
  int   i,limit;
  int   r_mat, vpn_mat, asid_mat;
  uint  asid, r, g;
  ulong vpn2, mask, evenodd, pfn;

  asid = EntryHi_L&0xffL;
  r    = (va_hi>>30)&3L;
  if(ty_cpu==R4300){
    limit = NTLB;
    vpn2  = ((va_hi<<19)|(va_lo>>13))&0x07ffffffL;
  }
  else{
    limit = NTLB;
    vpn2  = ((va_hi<<21)|(va_lo>>11))&0x1fffffffL;
  }
  for(i=0;i<limit;i++){
    mask = TLB[i].mask;
    g    = TLB[i].g;
    r_mat    = (TLB[i].r==r);
    vpn_mat  = ((TLB[i].vpn2|mask)==(vpn2|mask));
    asid_mat = (g||(TLB[i].asid==asid));
    if(r_mat&&vpn_mat&&asid_mat)
      break;
  }
  if(i<limit){ /* hit */
    *hit = 1;
    if(ty_cpu==R4300)
      mask = (mask<<13)|0x1fffL;
    else
      mask = (mask<<11)|0x7ffL;
    evenodd = 0x80000000L;
    while((mask&evenodd)==0L)
      evenodd >>= 1;
    if(va_lo&evenodd){/* odd page */ 
      pfn = TLB[i].pfn1;
      *c  = TLB[i].c1;
      *d  = TLB[i].d1;
      *v  = TLB[i].v1;
    }
    else{/* even page */
      pfn = TLB[i].pfn0;
      *c  = TLB[i].c0;
      *d  = TLB[i].d0;
      *v  = TLB[i].v0;
    }
    evenodd--;/* offset mask */
    if(ty_cpu==R4300)
      return ((pfn<<12)&(~evenodd))|(va_lo&evenodd);
    else
      return ((pfn<<10)&(~evenodd))|(va_lo&evenodd);
  }
  else{/* miss */
    *hit = 0;
    return 0L;
  }
}

ulong addchk(ulong hi, ulong lo, int *map, int *ca, int *err)
{
  int   ksu,kx,sx,ux;
  ulong dst0, dst1;
  int   cy;

  ksu = (Status>>3)&3L;
  kx  = (Status>>7)&1L;
  sx  = (Status>>6)&1L;
  ux  = (Status>>5)&1L;
  if(Status&0x6L)/* ERL or EXL */
    ksu = 0;
  switch(ksu){
  case 1:/* supervisor */
    *ca  = 3;
    *map = 1;
    if(sx){/* 64bit */
      ISUB64(hi, lo, 0x00000100L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xsuseg */
        *err = 0;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      ISUB64(hi, lo, 0x40000000L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* address error */
        *err = 1;
        return 0L;
      }
      ISUB64(hi, lo, 0x40000100L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xsseg */
        *err = 0;
        return 0L;
      }
      ISUB64(hi, lo, 0xffffffffL, 0xc0000000L, &dst1, &dst0, &cy);
      if(!cy){/* address error */
        *err = 1;
        return 0L;
      }
      ISUB64(hi, lo, 0xffffffffL, 0xe0000000L, &dst1, &dst0, &cy);
      if(!cy){/* csseg */
        *err = 0;
        return 0L;
      }
      *err = 1;
      return 0L;
    }
    else{/* 32bit */
      if(lo<0x80000000L){/* suseg */
        *err = 0;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      if(lo<0xc0000000L){/* address error */
        *err = 1;
        return 0L;
      }
      if(lo<0xe0000000L){/* sseg */
        *err = 0;
        return 0L;
      }
      *err = 1;
      return 0L;
    }
  case 2:/* user */
    *ca  = 3;
    *map = 1;
    if(ux){/* 64bit */
      ISUB64(hi, lo, 0x00000100L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xuseg */
        *err = 0;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      *err = 1;
      return 0L;
    }
    else{/* 32bit */
      if(lo<0x80000000L){/* useg */
        *err = 0;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      *err = 1;
      return 0L;
    }
  default:/* kernel */
    if(kx){ /* 64bit */
      ISUB64(hi, lo, 0x00000100L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xkuseg */
        *err = 0;
        *map = 1;
        *ca  = 3;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      ISUB64(hi, lo, 0x40000000L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* address error */
        *err = 1;
        *map = 0;
        *ca  = 2;
        return 0L;
      }
      ISUB64(hi, lo, 0x40000100L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xksseg */
        *err = 0;
        *map = 1;
        *ca  = 3;
        return 0L;
      }
      ISUB64(hi, lo, 0x80000000L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* address error */
        *err = 1;
        *map = 0;
        *ca  = 2;
        return 0L;
      }
      ISUB64(hi, lo, 0xc0000000L, 0x00000000L, &dst1, &dst0, &cy);
      if(!cy){/* xkphys */
        *ca  = (hi>>(59-32))&7L;
        *map = 0;
	if(hi&0x07ffffffL)
	  *err = 1;
	else
	  *err = 0;
        return lo;
      }
      ISUB64(hi, lo, 0xc00000ffL, 0x80000000L, &dst1, &dst0, &cy);
      if(!cy){/* xkseg */
        *err = 0;
        *map = 1;
        *ca  = 3;
        return 0L;
      }
      ISUB64(hi, lo, 0xffffffffL, 0x80000000L, &dst1, &dst0, &cy);
      if(!cy){/* address error */
        *err = 1;
        *map = 0;
        *ca  = 2;
        return 0L;
      }
      ISUB64(hi, lo, 0xffffffffL, 0xa0000000L, &dst1, &dst0, &cy);
      if(!cy){/* ckseg0 */
        *err = 0;
        *map = 0;
        *ca  = Config&7L;
        return lo&0x1fffffffL;
      }
      ISUB64(hi, lo, 0xffffffffL, 0xc0000000L, &dst1, &dst0, &cy);
      if(!cy){/* ckseg1 */
        *err = 0;
        *map = 0;
        *ca  = 2;
        return lo&0x1fffffffL;
      }
      *err = 0;
      *map = 1;
      *ca  = 3;
      return 0L;
    }
    else{/* 32bit */
      *err = 0;
      if(lo<0x80000000L){/* kuseg */
        *map = 1;
        *ca  = 3;
	if(Status&4L){
	  *map = 0;
	  *ca  = 2;
	  return lo;
	}
	else
	  return 0L;
      }
      if(lo<0xa0000000L){/* kseg0 */
        *map = 0;
        *ca  = Config&7L;
        return lo&0x1fffffffL;
      }
      if(lo<0xc0000000L){/* kseg1 */
        *map = 0;
        *ca  = 2;
        return lo&0x1fffffffL;
      }
      *ca  = 3;
      *map = 1;
      return 0L;
    }
  }
}

ulong addr_trans(ulong hi, ulong lo, int type, int *ca, int *err)
{
  ulong pa;
  int   m, c, e, d, v, hit;

  if(!addr64)
    hi = sign_extend(lo);
  pa = addchk(hi, lo, &m, &c, &e);
  if(e){/* Address Error */
    *ca  = 2;
    *err = (type==READ)? Exc_AdEL : Exc_AdES;
    set_badva(hi, lo);
  }
  else{
     if(m){/* mapped */
       pa = va2pa(hi, lo, ca, &d, &v, &hit);
       if(hit){
	 if(v){
	   *err = (type==READ)? Exc_NONE :
	          (d         )? Exc_NONE :
	                        Exc_Mod;
	   if(*err==Exc_Mod){
	     set_badva(hi, lo);
	     EntryHi_H  = hi;
	     EntryHi_L  = (EntryHi_L&0xffL)|
                          ((ty_cpu==R4300)? (lo&0xffffe000L):
                                            (lo&0xfffff800L));
	   }
	 }
	 else{/* TLB Invalid */
	   *err = (type==READ)? Exc_TLBL : Exc_TLBS;
	   set_badva(hi, lo);
	   EntryHi_H  = hi;
	   EntryHi_L  = (EntryHi_L&0xffL)|
                        ((ty_cpu==R4300)? (lo&0xffffe000L):
                                          (lo&0xfffff800L));
	 }
       }
       else{/* TLB Miss */
	 *err = (type==READ)? Exc_TLBML : Exc_TLBMS;
	 set_badva(hi, lo);
	 EntryHi_H  = hi;
	 EntryHi_L  = (EntryHi_L&0xffL)|
                      ((ty_cpu==R4300)? (lo&0xffffe000L):
                                        (lo&0xfffff800L));
       }
     }
     else{ /* unmapped */
       *err = Exc_NONE;
       *ca  = c;
     }
  }
  lastpa = pa;
  return pa;
}

void tlbr(void)
{
  int index;

  index = Index & 0x3fL;

  if(ty_cpu==R4300){
    PageMask = TLB[index].mask<<13;
    EntryLo0 = (TLB[index].pfn0<<6)|
               (TLB[index].c0<<3)|
               (TLB[index].d0<<2)|
               (TLB[index].v0<<1)|
                TLB[index].g;
    EntryLo1 = (TLB[index].pfn1<<6)|
               (TLB[index].c1<<3)|
               (TLB[index].d1<<2)|
               (TLB[index].v1<<1)|
                TLB[index].g;
    EntryHi_L = (TLB[index].vpn2<<13)|TLB[index].asid;
    EntryHi_H = (TLB[index].vpn2>>19)|(TLB[index].r<<30);
  }
  else{
    PageMask = TLB[index].mask<<11;
    EntryLo0 = (TLB[index].pfn0<<6)|
               (TLB[index].c0<<3)|
               (TLB[index].d0<<2)|
               (TLB[index].v0<<1)|
                TLB[index].g;
    EntryLo1 = (TLB[index].pfn1<<6)|
               (TLB[index].c1<<3)|
               (TLB[index].d1<<2)|
               (TLB[index].v1<<1)|
                TLB[index].g;
    EntryHi_L = (TLB[index].vpn2<<11)|TLB[index].asid;
    EntryHi_H = (TLB[index].vpn2>>21)|(TLB[index].r<<30);
  }
}

void tlbp(void)
{
  uint  asid, r, g;
  ulong vpn2, mask;
  int   i, limit;
  int   vpn_mat, r_mat, asid_mat;

  asid = EntryHi_L&0xffL;
  r    = (EntryHi_H>>30)&3L;
  if(ty_cpu==R4300){
    limit = NTLB;
    vpn2  = ((EntryHi_H<<19)|(EntryHi_L>>13))&0x07ffffffL;
  }
  else{
    limit = NTLB;
    vpn2  = ((EntryHi_H<<21)|(EntryHi_L>>11))&0x1fffffffL;
  }
  for(i=0;i<limit;i++){
    mask = TLB[i].mask;
    g    = TLB[i].g;
    r_mat    = (TLB[i].r==r);
    vpn_mat  = ((TLB[i].vpn2|mask)==(vpn2|mask));
    asid_mat = (g||(TLB[i].asid==asid));
    if(r_mat&&vpn_mat&&asid_mat)
      break;
  }
  if(i<limit){/* hit */
    Index = i;
  }
  else{
    Index = 0x80000000L;
  }
}

void update_random(void)
{
  if(Random==Wired)
    Random = (ty_cpu==R4300)? 47 : 31;
  else
    Random = Random - 1;
}

void update_count(void)
{
  if(mips32_en && (Cause & (1<<27)))
    return;
  Count++;
  if(Count==Compare){
    Cause |= 0x8000L;
    if(mips32_en)
      Cause |= 0x40000000L;
  }
}

int int_check(void)
{
  if((Status&1L)==0L)/* IE */
    return 0;
  if(Cause&Status&0xff00L)
    return 1;
  return 0;
}

void init_cp0(void)
{
  int i;
  Wired  = 0L;
  Random = NTLB;
  Status = Status |
           4L     | /* ERL */
           (ulong)(1<<22); /* BEV */
  Config = (ty_cpu==R4300)? 0x0002e480L:
                            0x00125900L;
  EntryHi_H  = 0xffffffffL;
  EntryHi_L  = 0x80000000L;
  EntryLo0   = 0L;
  EntryLo1   = 0L;
  PageMask   = 0L;
  for(i=0;i<NTLB;i++){
    Index = i;
    tlbwi();
  }
}

ulong get_lastpa(void)
{
  return lastpa;
}

void cp0_dump(void)
{
  printf("[CP0]\n");
  printf("pagemask:%08x entryhi:%08x%08x wired:%08x\n",
          PageMask, EntryHi_H,EntryHi_L, Wired);
  printf("entrylo0:%08x entrylo1:%08x index:%08x random:%08x\n",
          EntryLo0, EntryLo1, Index, Random);
  if(mips32_en){
    printf("prid:%08x config0:%08x config1:%08x\n",
            PRId, Config0, Config1);
    printf("config2:%08x config3:%08x lladdr:%08x\n",
            Config2, Config3, LLAddr);
  }
  else
    printf("prid:%08x config:%08x lladdr:%08x\n",
            PRId, Config, LLAddr);
  printf("context:%08x%08x badvaddr:%08x%08x\n",
          Context_H,Context, BadVAddr_H,BadVAddr_L);
  printf("count:%08x compare:%08x status:%08x cause:%08x\n",
          Count, Compare, Status, Cause);
  printf("epc:%08x%08x watchhi:%08x watchlo:%08x\n",
          EPC_H,EPC_L, WatchHi, WatchLo);
  printf("xcontext:%08x%08x perr:%08x cacheerr:%08x\n",
          XContext_H,XContext_L, PErr, CacheErr);
  printf("errorepc:%08x%08x taghi:%08x taglo:%08x\n",
          ErrorEPC_H,ErrorEPC_L, TagHi, TagLo);
}
