/*************************************************/
/* All rights reserved by Akira Nakamori. This   */
/* program must be uesed solely for the purpose  */ 
/* for which it was furnished by Akira Nakamori. */
/*                                               */
/*     Copyright (C) Akira Nakamori 2004         */
/*************************************************/
#include <stdio.h>
#include "define.h"
extern int   except;
extern int   inst64_en;
extern int   br_inst;
extern int   br_cond;
extern int   br_likely;
extern int   no_ds_br;
extern ulong target_hi, target_lo;
extern ulong brk_inst;

static int jal_flag = 0;
       int extend_flag = 0;
static ulong extend_code;
static int delay_slot = 0;

static ulong rx_hi, rx_lo;
static ulong ry_hi, ry_lo;
static ulong dst_hi, dst_lo;

static ulong PCH, PCL;
static ulong EXPCH, EXPCL;

void init_cpu16(void)
{
  jal_flag = 0;
  extend_flag = 0;
  delay_slot = 0;
}

static int mips16_reg_get(int reg)
{
  if(reg==0) return 16;
  if(reg==1) return 17;
  return reg;
}

static int PUSHP(ulong hi, ulong lo, int siz, int reg, int mode)
{
  ulong tmph, tmpl, dmyh, dmyl;
  int   cy;
  int   err;

  if(mode==64)
    siz = siz+siz;
  IADD64(hi, lo, 0, siz, &tmph, &tmpl, &cy);
  if(tmpl&3){
    set_badva(tmph, tmpl);
    return Exc_AdES;
  }
  if(mode==64){
    dmyl = get_dcaches(tmph, (tmpl&0xfffffff8L)+0, &err);
    dmyh = get_dcaches(tmph, (tmpl&0xfffffff8L)+4, &err);
  }
  else{
    dmyl = get_dcaches(tmph, tmpl&0xfffffffcL, &err);
  }
  if(err!=Exc_NONE){
    set_badva(tmph, tmpl);
    return err;
  }
  get_gr(reg, &dmyh, &dmyl);
  if(mode==64){
    put_dcache(tmph, (tmpl&0xfffffffcL)+0, dmyl);
    put_dcache(tmph, (tmpl&0xfffffffcL)+4, dmyh);
  }
  else{
    put_dcache(tmph, tmpl&0xfffffffcL, dmyl);
  }
  return Exc_NONE;
}

static int PUSHM(ulong hi, ulong lo, int siz, ulong *h, ulong *l, int reg, int mode)
{
  ulong tmph, tmpl, dmyh, dmyl;
  int   cy;
  int   err;

  if(mode==64)
    siz = siz+siz;
  ISUB64(hi, lo, 0, siz, &tmph, &tmpl, &cy);
  if(tmpl&3){
    set_badva(tmph, tmpl);
    return Exc_AdES;
  }
  if(mode==64){
    dmyl = get_dcaches(tmph, (tmpl&0xfffffff8L)+0, &err);
    dmyh = get_dcaches(tmph, (tmpl&0xfffffff8L)+4, &err);
  }
  else{
    dmyl = get_dcaches(tmph, tmpl&0xfffffffcL, &err);
  }
  if(err!=Exc_NONE){
    set_badva(tmph, tmpl);
    return err;
  }
  get_gr(reg, &dmyh, &dmyl);
  if(mode==64){
    put_dcache(tmph, (tmpl&0xfffffff8L)+0, dmyl);
    put_dcache(tmph, (tmpl&0xfffffff8L)+4, dmyh);
  }
  else{
    put_dcache(tmph, tmpl&0xfffffffcL, dmyl);
  }
  *h = tmph;
  *l = tmpl;
  return Exc_NONE;
}

static int POPM(ulong hi, ulong lo, int siz, ulong *h, ulong *l, int reg, int mode)
{
  ulong tmph, tmpl, dmyh, dmyl;
  int   cy;
  int   err;

  if(mode==64)
    siz = siz+siz;
  ISUB64(hi, lo, 0, siz, &tmph, &tmpl, &cy);
  if(tmpl&3){
    set_badva(tmph, tmpl);
    return Exc_AdEL;
  }
  if(mode==64){
    dmyl = get_dcachel(tmph, (tmpl&0xfffffff8L)+0, &err);
    dmyh = get_dcachel(tmph, (tmpl&0xfffffff8L)+4, &err);
  }
  else{
    dmyl = get_dcachel(tmph, tmpl&0xfffffffcL, &err);
  }
  if(err!=Exc_NONE){
    set_badva(tmph, tmpl);
    return err;
  }
  if(mode!=64){
    dmyh = (dmyl&0x80000000L)? 0xffffffffL : 0L;
  }
  set_gr(reg, dmyh, dmyl);
  *h = tmph;
  *l = tmpl;
  return Exc_NONE;
}

void do_save_restore(ulong extend, ulong insn, int mode)
{
  ulong sph,spl,tmph,tmpl;
  int   sr,ra,s0,s1,xs,a,args,astatic;
  long  size;
  int   cy;
  int   err;

  sr = ((insn&0x80)!=0);
  ra = ((insn&0x40)!=0);
  s0 = ((insn&0x20)!=0);
  s1 = ((insn&0x10)!=0);
  xs = (extend>>8)&7;
  a  = extend & 0xf;
  size = ((extend&0xf0)|(insn&0xf));
  if(extend)
    size = size << 3;
  else
    size = (size==0)? 128 : (size<<3);
  switch(a){
  case 0:
  case 4:
  case 8:
  case 12:
  case 14:
    astatic = 0; break;
  case 1:
  case 5:
  case 9:
  case 13:
    astatic = 1; break;
  case 2:
  case 6:
  case 10:
    astatic = 2; break;
  case 3:
  case 7:
    astatic = 3; break;
  case 11:
    astatic = 4; break;
  }
  get_gr(29, &sph, &spl);
  if(sr){/* save */
    switch(a){
    case 0:
    case 1:
    case 2:
    case 3:
    case 11:
      args = 0; break;
    case 4:
    case 5:
    case 6:
    case 7:
      args = 1; break;
    case 8:
    case 9:
    case 10:
      args = 2; break;
    case 12:
    case 13:
      args = 3; break;
    case 14:
      args = 4; break;
    }
    err = Exc_NONE;
    if(args>0){
      err = PUSHP(sph, spl, 0, 4, mode);
      if((args>1)&&(err==Exc_NONE)){
	err = PUSHP(sph, spl, 4, 5, mode);
	if((args>2)&&(err==Exc_NONE)){
	  err = PUSHP(sph, spl, 8, 6, mode);
	  if((args>3)&&(err==Exc_NONE)){
	    err = PUSHP(sph, spl, 12, 7, mode);
	  }
	}
      }
    }
    tmph = sph;
    tmpl = spl;
    if(ra&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 31, mode);
    if((xs>6)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 30, mode);
    if((xs>5)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 23, mode);
    if((xs>4)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 22, mode);
    if((xs>3)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 21, mode);
    if((xs>2)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 20, mode);
    if((xs>1)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 19, mode);
    if((xs>0)&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 18, mode);
    if(s1&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 17, mode);
    if(s0&&(err==Exc_NONE))
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 16, mode);
    if((astatic>0)&&(err==Exc_NONE)){
      err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 7, mode);
      if((astatic>1)&&(err==Exc_NONE)){
	err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 6, mode);
	if((astatic>2)&&(err==Exc_NONE)){
	  err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 5, mode);
	  if((astatic>3)&&(err==Exc_NONE)){
	    err = PUSHM(tmph, tmpl, 4, &tmph, &tmpl, 4, mode);
	  }
	}
      }
    }
    if(err==Exc_NONE){
      ISUB64(sph, spl, 0, size, &tmph, &tmpl, &cy);
      set_gr(29, tmph, tmpl);
    }
  }
  else{/* restore */
    IADD64(sph, spl, 0, size, &tmph, &tmpl, &cy);
    sph = tmph;
    spl = tmpl;
    err = Exc_NONE;
    if(ra&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 31, mode);
    if((xs>6)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 30, mode);
    if((xs>5)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 23, mode);
    if((xs>4)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 22, mode);
    if((xs>3)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 21, mode);
    if((xs>2)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 20, mode);
    if((xs>1)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 19, mode);
    if((xs>0)&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 18, mode);
    if(s1&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 17, mode);
    if(s0&&(err==Exc_NONE))
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 16, mode);
    if((astatic>0)&&(err==Exc_NONE)){
      err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 7, mode);
      if((astatic>1)&&(err==Exc_NONE)){
	err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 6, mode);
	if((astatic>2)&&(err==Exc_NONE)){
	  err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 5, mode);
	  if((astatic>3)&&(err==Exc_NONE)){
	    err = POPM(tmph, tmpl, 4, &tmph, &tmpl, 4, mode);
	  }
	}
      }
    }
    if(err==Exc_NONE)
      set_gr(29, sph, spl);
  }
  except = err;
}

static void exec_mips16_RR(int decRR, int decRX, int decRY, int decSA, ulong insn)
{
  int cy, lt, eq;
  ulong dm,dm1,dm2,dm3;
  int ssign, tsign, dsign;

  switch(decRR){
  case 000:/* j(al)r */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      switch(decRY&0x7){
      case 0:/* jr rx */
	target_hi = rx_hi;
	target_lo = rx_lo;
	br_inst = 2;
	br_cond = 1;
	break;
      case 1:
	if(decRX==16){ /* jr ra */
	  get_gr(31, &target_hi, &target_lo);
	  br_inst = 2;
	  br_cond = 1;
	}
	else{
	  except = Exc_RI;
	}
	break;
      case 2:/* jalr ra,rx */
	IADD64(PCH, PCL, 0L, 4L, &dst_hi, &dst_lo, &cy);
	set_gr(31, dst_hi, dst_lo);
	target_hi = rx_hi;
	target_lo = rx_lo;
	br_inst = 2;
	br_cond = 1;
	break;
      case 4:/* jrc rx */
	target_hi = rx_hi;
	target_lo = rx_lo;
	no_ds_br  = 1;
	break;
      case 5:
	if(decRX==16){ /* jrc ra */
	  get_gr(31, &target_hi, &target_lo);
	  no_ds_br  = 1;
	}
	else{
	  except = Exc_RI;
	}
	break;
      case 6:/* jalrc ra,rx */
	IADD64(PCH, PCL, 0L, 2L, &dst_hi, &dst_lo, &cy);
	set_gr(31, dst_hi, dst_lo);
	target_hi = rx_hi;
	target_lo = rx_lo;
	no_ds_br  = 1;
	break;
      default:
	except = Exc_RI;
      }
    }
    break;
  case 001:
    except = Exc_RI;
    break;
  case 002:/* slt */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      CMP64(rx_hi, rx_lo, ry_hi, ry_lo, &lt, &eq);
      if(lt&&(!eq))
	set_gr(24, 0L, 1L);
      else
	set_gr(24, 0L, 0L);
    }
    break;
  case 003:/* sltu */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      UCMP64(rx_hi, rx_lo, ry_hi, ry_lo, &lt, &eq);
      if(lt&&(!eq))
	set_gr(24, 0L, 1L);
      else
	set_gr(24, 0L, 0L);
    }
    break;
  case 004:/* sllv */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      LSHIFT(ry_hi, ry_lo, rx_lo&0x1f, &dm, &dst_hi, &dst_lo);
      set_gr(decRY, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 005:/* break */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      except = Exc_Bp;
    }
    break;
  case 006:/* srlv */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      RSHIFTL(0L, ry_lo, rx_lo&0x1f, &dst_hi, &dst_lo);
      set_gr(decRY, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 007:/* srav */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      RSHIFTA(ry_hi, ry_lo, rx_lo&0x1f, &dst_hi, &dst_lo);
      set_gr(decRY, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 010:/* dsrl */
    if(inst64_en){
      if(extend_flag){
	decSA=(insn&0x20)|((insn>>6)&0x1f);
      }
      else{
	decRX &= 7;
	if(decRX==0)
	  decSA=8;
	else
	  decSA=decRX;
      }
      RSHIFTL(ry_hi, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRY, dst_hi, dst_lo);
    }
    else{
      except = Exc_RI;
    }
    break;
  case 011:/* syscall */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      except = Exc_Sys;
    }
    break;
  case 012:/* cmp */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      dst_lo = rx_lo^ry_lo;
      dst_hi = rx_hi^ry_hi;
      set_gr(24, dst_hi, dst_lo);
    }
    break;
  case 013:/* neg */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      ISUB64(0L, 0L, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 014:/* and */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      dst_lo = rx_lo&ry_lo;
      dst_hi = rx_hi&ry_hi;
      set_gr(decRX, dst_hi, dst_lo);
    }
    break;
  case 015:/* or */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      dst_lo = rx_lo|ry_lo;
      dst_hi = rx_hi|ry_hi;
      set_gr(decRX, dst_hi, dst_lo);
    }
    break;
  case 016:/* xor */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      dst_lo = rx_lo^ry_lo;
      dst_hi = rx_hi^ry_hi;
      set_gr(decRX, dst_hi, dst_lo);
    }
    break;
  case 017:/* not */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      dst_lo = ~ry_lo;
      dst_hi = ~ry_hi;
      set_gr(decRX, dst_hi, dst_lo);
    }
    break;
  case 020:/* mfhi */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      if(decRY&7)
	except = Exc_RI;
      else{
	get_hi(&dst_hi, &dst_lo);
	set_gr(decRX, dst_hi, dst_lo);
      }
    }
    break;
  case 021:
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      switch(decRY&7){
      case 0:/* ZEB */
	dst_hi = 0;
	dst_lo = rx_lo &0xff;
	set_gr(decRX, dst_hi, dst_lo);
	break;
      case 1:/* ZEH */
	dst_hi = 0;
	dst_lo = rx_lo &0xffff;
	set_gr(decRX, dst_hi, dst_lo);
	break;
      case 2:/* ZEW */
	if(inst64_en){
	  dst_hi = 0;
	  dst_lo = rx_lo;
	  set_gr(decRX, dst_hi, dst_lo);
	}
	else{
	  except = Exc_RI;
	}
	break;
      case 4:/* SEB */
	rx_lo &= 0xff;
	dst_hi = (rx_lo &0x80)?  0xffffffff        : 0;
	dst_lo = (rx_lo &0x80)? (0xffffff00|rx_lo) : rx_lo;
	set_gr(decRX, dst_hi, dst_lo);
	break;
      case 5:/* SEH */
	rx_lo &= 0xffff;
	dst_hi = (rx_lo &0x8000)?  0xffffffff        : 0;
	dst_lo = (rx_lo &0x8000)? (0xffff0000|rx_lo) : rx_lo;
	set_gr(decRX, dst_hi, dst_lo);
	break;
      case 6:/* SEW */
	if(inst64_en){
	  dst_hi = (rx_lo &0x80000000)? 0xffffffff : 0;
	  dst_lo = rx_lo;
	  set_gr(decRX, dst_hi, dst_lo);
	}
	else{
	  except = Exc_RI;
	}
	break;
      default:
	except = Exc_RI;
      }
    }
    break;
  case 022:/* mflo */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      if(decRY&7)
	except = Exc_RI;
      else{
	get_lo(&dst_hi, &dst_lo);
	set_gr(decRX, dst_hi, dst_lo);
      }
    }
    break;
  case 023:/* dsra */
    if(inst64_en){
      if(extend_flag){
	decSA=(insn&0x20)|((insn>>6)&0x1f);
      }
      else{
	decRX &= 7;
	if(decRX==0)
	  decSA=8;
	else
	  decSA=decRX;
      }
      RSHIFTA(ry_hi, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRY, dst_hi, dst_lo);
    }
    else{
      except = Exc_RI;
    }
    break;
  case 024:/* dsllv */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	LSHIFT(ry_hi, ry_lo, rx_lo&0x3f, &dm, &dst_hi, &dst_lo);
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 025:
    except = Exc_RI;
    break;
  case 026:/* dsrlv */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	RSHIFTL(ry_hi, ry_lo, rx_lo&0x3f, &dst_hi, &dst_lo);
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 027:/* dsrav */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	RSHIFTA(ry_hi, ry_lo, rx_lo&0x3f, &dst_hi, &dst_lo);
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 030:/* mult */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      UMUL64(sign_extend(rx_lo), rx_lo, sign_extend(ry_lo), ry_lo,
	     &dm3, &dm2, &dm1, &dm);
      set_lo(sign_extend(dm), dm);
      set_hi(sign_extend(dm1), dm1);
    }
    break;
  case 031:/* multu */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      UMUL32(rx_lo, ry_lo, &dm1, &dm);
      set_lo(sign_extend(dm), dm);
      set_hi(sign_extend(dm1), dm1);
    }
    break;
  case 032:/* div */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      ssign = ((rx_lo&0x80000000L)!=0);
      tsign = ((ry_lo&0x80000000L)!=0);
      dsign = ssign ^ tsign;
      if(ssign){
	rx_lo = ~rx_lo+1L;
      }
      if(tsign){
	ry_lo = ~ry_lo+1L;
      }
      UDIV32(rx_lo, ry_lo, &dm, &dm1);
      if(dsign){
	dm = ~dm+1L;
      }
      if(ssign){
	dm1 = ~dm1+1L;
      }
      set_lo(sign_extend(dm), dm);
      set_hi(sign_extend(dm1), dm1);
    }
    break;
  case 033:/* divu */
    if(extend_flag){
      except = Exc_RI;
    }
    else{
      UDIV32(rx_lo, ry_lo, &dm, &dm1);
      set_lo(sign_extend(dm), dm);
      set_hi(sign_extend(dm1), dm1);
    }
    break;
  case 034:/* dmult */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	ssign = ((rx_hi&0x80000000L)!=0);
	tsign = ((ry_hi&0x80000000L)!=0);
	dsign = ssign ^ tsign;
	if(ssign){
	  ISUB64(0L, 0L, rx_hi, rx_lo, &dst_hi, &dst_lo, &cy);
	  rx_hi = dst_hi;
	  rx_lo = dst_lo;
	}
	if(tsign){
	  ISUB64(0L, 0L, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
	  ry_hi = dst_hi;
	  ry_lo = dst_lo;
	}
	UMUL64(rx_hi, rx_lo, ry_hi, ry_lo, &dm3, &dm2, &dm1, &dm);
	if(dsign){
	  NEG128(dm3, dm2, dm1, dm, &dm3, &dm2, &dm1, &dm);
	}
	set_lo(dm1, dm);
	set_hi(dm3, dm2);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 035:/* dmultu */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	UMUL64(rx_hi, rx_lo, ry_hi, ry_lo, &dm3, &dm2, &dm1, &dm);
	set_lo(dm1, dm);
	set_hi(dm3, dm2);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 036:/* ddiv */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	ssign = ((rx_hi&0x80000000L)!=0);
	tsign = ((ry_hi&0x80000000L)!=0);
	dsign = ssign ^ tsign;
	if(ssign){
	  ISUB64(0L, 0L, rx_hi, rx_lo, &dst_hi, &dst_lo, &cy);
	  rx_hi = dst_hi;
	  rx_lo = dst_lo;
	}
	if(tsign){
	  ISUB64(0L, 0L, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
	  ry_hi = dst_hi;
	  ry_lo = dst_lo;
	}
	UDIV64(rx_hi, rx_lo, ry_hi, ry_lo, &dm1, &dm, &dm3, &dm2);
	if(dsign){
	  ISUB64(0L, 0L, dm1, dm, &dm1, &dm, &cy);
	}
	if(ssign){
	  ISUB64(0L, 0L, dm3, dm2, &dm3, &dm2, &cy);
	}
	set_lo(dm1, dm);
	set_hi(dm3, dm2);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 037:/* ddivu */
    if(inst64_en){
      if(extend_flag){
	except = Exc_RI;
      }
      else{
	UDIV64(rx_hi, rx_lo, ry_hi, ry_lo, &dm1, &dm, &dm3, &dm2);
	set_lo(dm1, dm);
	set_hi(dm3, dm2);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  }
}

static void exec_mips16_extend(int insn, ulong pch, ulong pcl)
{
  ulong	decOP,decRX,decRY,decRZ,decSA,decFUNC,decRR,
        decIMMD,decIMMD5,decTARG,decCODE;
  ulong	tmp_hi, tmp_lo;
  ulong wrk_hi, wrk_lo;
  int   cy, lt, eq;
  ulong insn32;

  insn32 = (insn<<16)|extend_code;

  brk_inst = insn32;

  decOP	=               (insn32>>(11+16))&0x1f;
  decRX	=mips16_reg_get((insn32>>( 8+16))&0x7);
  decRY	=mips16_reg_get((insn32>>( 5+16))&0x7);
  decRZ	=mips16_reg_get((insn32>>( 2+16))&0x7);
  decSA	=               (insn32>>( 2+16))&0x7;
  decFUNC=              (insn32>>    16 )&0x3;
  decRR	=               (insn32>>    16 )&0x1f;
  decIMMD5=             (insn32>>    16 )&0x1f;
  decSA   = (insn32&0x400000L)? (0x20|decSA):decSA;
  decIMMD = ((insn32&0x1f)<<11)|(insn32&0x7e0)|decIMMD5;
  decTARG = decIMMD;
  decCODE =               (insn32>>( 5+16))&0x1f;

  br_likely = 0;
  br_inst   = 0;
  no_ds_br  = 0;
  PCH = pch;
  PCL = pcl;
  get_gr(decRX, &rx_hi, &rx_lo);
  get_gr(decRY, &ry_hi, &ry_lo);

  if(jal_flag)
    decOP = 003;

  switch(decOP){
  case 000:/* addiusp */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000L|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 001:/* addiupc */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000L|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    IADD64(EXPCH, EXPCL&0xfffffffcL, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 002:/* b */
    if(decTARG&0x8000){
      tmp_lo = (ulong)((0xffff0000|decTARG)<<1);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)(decTARG<<1);
      tmp_hi = 0;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
    bt_refer(target_lo,1);
    no_ds_br  = 1;
    break;
  case 003:/* jal(x) */
    if(jal_flag==0){
      except = Exc_RI;
    }
    else{
      target_lo = (EXPCL&0xf0000000)|
	((((insn32&0x1f)<<21)|((insn32&0x3e0)<<11)|((insn32>>16)&0xffff))
	 <<2);
      target_hi = EXPCH;
      if((insn32&0x400)==0L)/* jal */{
	target_lo |= 1L;
      }
      IADD64(PCH, PCL, 0L, 4L, &dst_hi, &dst_lo, &cy);
      set_gr(31, dst_hi, dst_lo);
      br_inst = 4;
      br_cond = 1;
      jal_flag=0;
    }
    break;
  case 004:/* beqz */
    if(decTARG&0x8000){
      tmp_lo = (ulong)((0xffff0000|decTARG)<<1);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)(decTARG<<1);
      tmp_hi = 0L;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    if((rx_hi|rx_lo)==0L){
      IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
      bt_refer(target_lo,0);
    }
    else{
      target_hi = dst_hi;
      target_lo = dst_lo;
      bt_refer(target_lo,1);
    }
    no_ds_br  = 1;
    break;
  case 005:/* bnez */
    if(decTARG&0x8000){
      tmp_lo = (ulong)((0xffff0000|decTARG)<<1);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)(decTARG<<1);
      tmp_hi = 0L;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    if((rx_hi|rx_lo)!=0L){
      IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
      bt_refer(target_lo,0);
    }
    else{
      target_hi = dst_hi;
      target_lo = dst_lo;
      bt_refer(target_lo,1);
    }
    no_ds_br  = 1;
    break;
  case 006:/* SHIFT */
    decSA=((insn32>>6)&0x1f)|((insn32)&0x20);
    switch(decFUNC){
    case 0:/* sll  */
      LSHIFT(ry_hi, ry_lo, decSA, &tmp_lo, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
      break;
    case 1:/* dsll */
      if(inst64_en){
	LSHIFT(ry_hi, ry_lo, decSA, &tmp_lo, &dst_hi, &dst_lo);
	set_gr(decRX, dst_hi, dst_lo);
      }
      else{
	except = Exc_RI;
      }
      break;
    case 2:/* srl  */
      RSHIFTL(0L, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
      break;
    default:/* sra */
      RSHIFTA(ry_hi, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 007:/* ld */
    if(decIMMD&0x8000){
      tmp_lo = (long)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    if(inst64_en){
      IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      if(dst_lo&7L){
	except = Exc_AdEL;
	set_badva(dst_hi, dst_lo);
      }
      else{
	wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	  set_gr(decRY, wrk_hi, wrk_lo);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 010:/* RRI-A */
    decIMMD=((insn32&0xf)<<11)|(insn32&0x7f0)|((insn32>>16)&0xf);
    if(decRR&0x10){/* daddiu */
      if(decIMMD&0x4000){
	tmp_lo = (ulong)(0xffff8000|decIMMD);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = decIMMD;
	tmp_hi = 0L;
      }
      if(inst64_en){
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
      }
      else{
	except =Exc_RI;
      }
    }
    else{/* addiu */
      if(decIMMD&0x4000){
	tmp_lo = (ulong)(0xffff8000|decIMMD);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = decIMMD;
	tmp_hi = 0L;
      }
      IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      set_gr(decRY, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 011:/* addiu8 */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 012:/* slti */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    CMP64(rx_hi, rx_lo, tmp_hi, tmp_lo, &lt, &eq);
    if(lt&&(!eq))
      set_gr(24, 0L, 1L);
    else
      set_gr(24, 0L, 0L);
    break;
  case 013:/* sltiu */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    UCMP64(rx_hi, rx_lo, tmp_hi, tmp_lo, &lt, &eq);
    if(lt&&(!eq))
      set_gr(24, 0L, 1L);
    else
      set_gr(24, 0L, 0L);
    break;
  case 014:/* l8 */
    switch((insn32>>(8+16))&7){
    case 0:/* bteqz */
      IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
      if(decTARG&0x8000){
	tmp_lo = (ulong)((0xffff0000|decTARG)<<1);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(decTARG<<1);
	tmp_hi = 0L;
      }
      get_gr(24, &wrk_hi, &wrk_lo);
      if((wrk_hi|wrk_lo)==0L){
	IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
	bt_refer(target_lo,0);
      }
      else{
	target_hi = dst_hi;
	target_lo = dst_lo;
	bt_refer(target_lo,1);
      }
      no_ds_br = 1;
      break;
    case 1:/* btnez */
      IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
      if(decTARG&0x8000){
	tmp_lo = (ulong)((0xffff0000|decTARG)<<1);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(decTARG<<1);
	tmp_hi = 0L;
      }
      get_gr(24, &wrk_hi, &wrk_lo);
      if((wrk_hi|wrk_lo)!=0L){
	IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
	bt_refer(target_lo,0);
      }
      else{
	target_hi = dst_hi;
	target_lo = dst_lo;
	bt_refer(target_lo,1);
      }
      no_ds_br = 1;
      break;
    case 2:/* swrasp */
      if(decIMMD&0x8000){
	tmp_lo = (ulong)(0xffff0000|decIMMD);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)decIMMD;
	tmp_hi = 0L;
      }
      get_gr(29, &wrk_hi, &wrk_lo);
      get_gr(31, &rx_hi, &rx_lo);
      IADD64(wrk_hi, wrk_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      if(dst_lo&0x3){
	except = Exc_AdES;
	set_badva(dst_hi, dst_lo);
      }
      else{
	wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  put_dcache(dst_hi, dst_lo&0xfffffffcL, rx_lo);
	}
      }
      break;
    case 3:/* adjsp */
      if(decIMMD&0x8000){
	tmp_lo = (ulong)(0xffff0000|decIMMD);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)decIMMD;
	tmp_hi = 0L;
      }
      get_gr(29, &wrk_hi, &wrk_lo);
      IADD64(wrk_hi, wrk_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      set_gr(29, sign_extend(dst_lo), dst_lo);
      break;
    case 4:/* svrs */
      do_save_restore(extend_code,insn,32);
      break;
    case 5:/* mov32r */
      except = Exc_RI;
      break;
    case 6:
      except = Exc_RI;
      break;
    default:/* movr32 */
      except = Exc_RI;
    }
    break;
  case 015:/* li */
    set_gr(decRX, 0L, decIMMD);
    break;
  case 016:/* cmpi */
    tmp_lo = (ulong)decIMMD;
    tmp_hi = 0L;
    dst_lo = rx_lo^tmp_lo;
    dst_hi = rx_hi^tmp_hi;
    set_gr(24, dst_hi, dst_lo);
    break;
  case 017:/* sd */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    if(inst64_en){
      IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      if(dst_lo&7L){
    	except = Exc_AdES;
     	set_badva(dst_hi, dst_lo);
      }
      else{
     	wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
       	if(except!=Exc_NONE)
     	  set_badva(dst_hi, dst_lo);
       	if(except==Exc_NONE){
    	  wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	  put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	  put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 020:/* lb */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3){
      case 0:
	break;
      case 1:
	wrk_lo = wrk_lo>> 8;
	break;
      case 2:
	wrk_lo = wrk_lo>>16;
	break;
      case 3:
	wrk_lo = wrk_lo>>24;
	break;
      }
      if(wrk_lo&0x80L){
	dst_lo = 0xffffff00L|(wrk_lo&0x000000ffL);
	dst_hi = 0xffffffffL;
      }
      else{
	dst_lo = (wrk_lo&0x000000ffL);
	dst_hi = 0L;
      }
      set_gr(decRY, dst_hi, dst_lo);
    }
    break;
  case 021:/* lh */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3){
	case 0:
	  break;
	case 1:
	  break;
	case 2:
	  wrk_lo = wrk_lo>>16;
	  break;
	case 3:
	  wrk_lo = wrk_lo>>16;
	  break;
	}
	if(wrk_lo&0x8000L){
	  dst_lo = 0xffff0000L|(wrk_lo&0x0000ffffL);
	  dst_hi = 0xffffffffL;
	}
	else{
	  dst_lo = (wrk_lo&0x0000ffffL);
	  dst_hi = 0L;
	}
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    break;
  case 022:/* lwsp */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRX, wrk_hi, wrk_lo);
      }
    }
    break;
  case 023:/* lw */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRY, wrk_hi, wrk_lo);
      }
    }
    break;
  case 024:/* lbu */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3){
      case 0:
	break;
      case 1:
	wrk_lo = wrk_lo>> 8;
	break;
      case 2:
	wrk_lo = wrk_lo>>16;
	break;
      case 3:
	wrk_lo = wrk_lo>>24;
	break;
      }
      dst_lo = (wrk_lo&0x000000ffL);
      dst_hi = 0L;
      set_gr(decRY, dst_hi, dst_lo);
    }
    break;
  case 025:/* lhu */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3){
	case 0:
	  break;
	case 1:
	  break;
	case 2:
	  wrk_lo = wrk_lo>>16;
	  break;
	case 3:
	  wrk_lo = wrk_lo>>16;
	  break;
	}
	dst_lo = (wrk_lo&0x0000ffffL);
	dst_hi = 0L;
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    break;
  case 026:/* lwpc */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(EXPCH, EXPCL&0xfffffffcL, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRX, wrk_hi, wrk_lo);
      }
    }
    break;
  case 027:/* lwu */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    if(inst64_en){
      IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      if(dst_lo&3L){
	except = Exc_AdEL;
 	  set_badva(dst_hi, dst_lo);
     }
      else{
	wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  set_gr(decRY, 0L, wrk_lo);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 030:/* sb */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3L){
      case 0:
	wrk_lo = (ry_lo&0x000000ffL)|(wrk_lo&0xffffff00L);
	break;
      case 1:
	wrk_lo = ((ry_lo&0x000000ffL)<<8)|(wrk_lo&0xffff00ffL);
	break;
      case 2:
	wrk_lo = ((ry_lo&0x000000ffL)<<16)|(wrk_lo&0xff00ffffL);
	break;
      case 3:
	wrk_lo = ((ry_lo&0x000000ffL)<<24)|(wrk_lo&0x00ffffffL);
	break;
      }
      put_dcache(dst_hi, dst_lo&0xfffffffcL, wrk_lo);
    }
    break;
  case 031:/* sh */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3L){
	case 0:
	  wrk_lo = (ry_lo&0x0000ffffL)|(wrk_lo&0xffff0000L);
	  break;
	case 1:
	  wrk_lo = (ry_lo&0x0000ffffL)|(wrk_lo&0xffff0000L);
	  break;
	case 2:
	  wrk_lo = ((ry_lo&0x0000ffffL)<<16)|(wrk_lo&0x0000ffffL);
	  break;
	case 3:
	  wrk_lo = ((ry_lo&0x0000ffffL)<<16)|(wrk_lo&0x0000ffffL);
	  break;
	}
	put_dcache(dst_hi, dst_lo&0xfffffffcL, wrk_lo);
      }
    }
    break;
  case 032:/* swsp */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	put_dcache(dst_hi, dst_lo&0xfffffffcL, rx_lo);
      }
    }
    break;
  case 033:/* sw */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	put_dcache(dst_hi, dst_lo&0xfffffffcL, ry_lo);
      }
    }
    break;
  case 034:/* RRR */
    except = Exc_RI;
    break;
  case 035:/* RR */
    exec_mips16_RR((int)decRR,(int)decRX,(int)decRY,(int)decSA,insn32);
    break;
  case 036:/* extend */
    except = Exc_RI;
    break;
  case 037:/* I64 */
    if(decIMMD&0x8000){
      tmp_lo = (ulong)(0xffff0000|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = (ulong)decIMMD;
      tmp_hi = 0L;
    }
    if(inst64_en){
      switch(decRX&7){
      case 0:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdEL;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    set_gr(decRY, wrk_hi, wrk_lo);
	  }
	}
	break;
      case 1:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdES;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	  }
	}
	break;
      case 2:
	get_gr(29, &rx_hi, &rx_lo);
	get_gr(31, &ry_hi, &ry_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdES;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	  }
	}
	break;
      case 3:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(29, dst_hi, dst_lo);
	break;
      case 4:
	IADD64(EXPCH, EXPCL&0xfffffff8L, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdEL;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    set_gr(decRY, wrk_hi, wrk_lo);
	  }
	}
	break;
      case 5:
	IADD64(ry_hi, ry_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
	break;
      case 6:
	IADD64(EXPCH, EXPCL&0xfffffffcL, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
	break;
      default:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  }
}

void execute16(ulong pch, ulong pcl)
{
  int   decOP,decRX,decRY,decRZ,decSA,decFUNC,
        decRR,decIMMD,decIMMD5,decTARG,decCODE;
  int   cy;
  int   lt,eq;
  int   insn;
  ulong insn32;
  ulong tmp_hi,tmp_lo;
  ulong wrk_hi,wrk_lo;

  br_likely = 0;
  br_inst   = 0;
  no_ds_br  = 0;
  PCH = pch;
  PCL = pcl;

  insn32 = get_icache(pch,pcl,&except);

  if(except!=Exc_NONE){
    set_badva(pch, pcl);
    return;
  }

  if(pcl&2L)
    insn = (insn32>>16)&0xffffL;
  else
    insn = insn32&0xffffL;

  brk_inst = (ulong)insn;

  decOP    =               (insn>>11)&0x1f;
  decRX    = mips16_reg_get((insn>> 8)&0x7);
  decRY    = mips16_reg_get((insn>> 5)&0x7);
  decRZ    = mips16_reg_get((insn>> 2)&0x7);
  decSA    =                (insn>> 2)&0x7;
  decFUNC  =                 insn     &0x3;
  decRR    =                 insn     &0x1f;
  decIMMD  =                 insn     &0xff;
  decIMMD5 =                 insn     &0x1f;
  decTARG  =                 insn     &0x7ff;
  decCODE  =                (insn>> 5)&0x1f;

  except = Exc_NONE;
  if(extend_flag){
    exec_mips16_extend(insn, pch, pcl);
    delay_slot = br_inst;
    if(delay_slot){
      if(!extend_flag){/* no change EXPC by JAL */
	EXPCH = PCH;
	EXPCL = PCL;
      }
    }
    if(except==Exc_NONE)
      extend_flag = 0;
    return;
  }
  get_gr(decRX, &rx_hi, &rx_lo);
  get_gr(decRY, &ry_hi, &ry_lo);
  switch(decOP){
  case 000:/* addiusp */
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 001:/* addiupc */
    if(delay_slot)
      IADD64(EXPCH, EXPCL&0xfffffffcL, 0L, (ulong)(decIMMD<<2),
             &dst_hi, &dst_lo, &cy);
    else
      IADD64(pch, pcl&0xfffffffcL, 0L, (ulong)(decIMMD<<2),
             &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 002:/* b */
    if(decTARG&0x400){
      tmp_lo = (0xfffff800L|decTARG)<<1;
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decTARG<<1;
      tmp_hi = 0L;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
    bt_refer(target_lo,1);
    no_ds_br  = 1;
    break;
  case 003:/* jal(x) */
    extend_flag = 1;
    extend_code = insn;
    jal_flag=1;
    EXPCH = PCH;
    EXPCL = PCL;
    break;
  case 004:/* beqz */
    if(decIMMD&0x80){
      tmp_lo = (0xffffff00L|decIMMD)<<1;
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD<<1;
      tmp_hi = 0L;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    if((rx_hi|rx_lo)==0L){
      IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
      bt_refer(target_lo,0);
    }
    else{
      target_hi = dst_hi;
      target_lo = dst_lo;
      bt_refer(target_lo,1);
    }
    no_ds_br  = 1;
    break;
  case 005:/* bnez */
    if(decIMMD&0x80){
      tmp_lo = (0xffffff00L|decIMMD)<<1;
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD<<1;
      tmp_hi = 0L;
    }
    IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
    if((rx_hi|rx_lo)!=0L){
      IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
      bt_refer(target_lo,0);
    }
    else{
      target_hi = dst_hi;
      target_lo = dst_lo;
      bt_refer(target_lo,1);
    }
    no_ds_br  = 1;
    break;
  case 006:/* SHIFT */
    if(decSA==0)
      decSA = 8;
    switch(decFUNC){
    case 0:/* sll  */
      LSHIFT(ry_hi, ry_lo, decSA, &tmp_lo, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
      break;
    case 1:/* dsll */
      if(inst64_en){
	LSHIFT(ry_hi, ry_lo, decSA, &tmp_lo, &dst_hi, &dst_lo);
	set_gr(decRX, dst_hi, dst_lo);
      }
      else{
	except = Exc_RI;
      }
      break;
    case 2:/* srl  */
      RSHIFTL(0L, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
      break;
    default:/* sra */
      RSHIFTA(ry_hi, ry_lo, decSA, &dst_hi, &dst_lo);
      set_gr(decRX, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 007:/* ld */
    if(inst64_en){
      IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
      if(dst_lo&7L){
	except = Exc_AdEL;
	set_badva(dst_hi, dst_lo);
      }
      else{
	wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	  set_gr(decRY, wrk_hi, wrk_lo);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 010:/* RRI-A */
    if(insn&0x10){/* daddiu */
      if(inst64_en){
	if(insn&0x8){
	  tmp_lo = (ulong)(0xfffffff0|(insn&0xf));
	  tmp_hi = 0xffffffffL;
	}
	else{
	  tmp_lo = (ulong)(insn&0xf);
	  tmp_hi = 0L;
	}
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
      }
      else{
	except =Exc_RI;
      }
    }
    else{/* addiu */
      if(insn&0x8){
	tmp_lo = (ulong)(0xfffffff0|(insn&0xf));
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(insn&0xf);
	tmp_hi = 0L;
      }
      IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      set_gr(decRY, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 011:/* addiu8 */
    if(decIMMD&0x80){
      tmp_lo = (ulong)(0xffffff00|decIMMD);
      tmp_hi = 0xffffffffL;
    }
    else{
      tmp_lo = decIMMD;
      tmp_hi = 0L;
    }
    IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
    set_gr(decRX, sign_extend(dst_lo), dst_lo);
    break;
  case 012:/* slti */
    CMP64(rx_hi, rx_lo, 0L, (ulong)decIMMD, &lt, &eq);
    if(lt&&(!eq))
      set_gr(24, 0L, 1L);
    else
      set_gr(24, 0L, 0L);
    break;
  case 013:/* sltiu */
    UCMP64(rx_hi, rx_lo, 0L, (ulong)decIMMD, &lt, &eq);
    if(lt&&(!eq))
      set_gr(24, 0L, 1L);
    else
      set_gr(24, 0L, 0L);
    break;
  case 014:/* l8 */
    switch((insn>>8)&7){
    case 0:/* bteqz */
      IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
      if(decIMMD&0x80){
	tmp_lo = (ulong)((0xffffff00|decIMMD)<<1);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(decIMMD<<1);
	tmp_hi = 0L;
      }
      get_gr(24, &wrk_hi, &wrk_lo);
      if((wrk_hi|wrk_lo)==0L){
	IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
	bt_refer(target_lo,0);
      }
      else{
	target_hi = dst_hi;
	target_lo = dst_lo;
	bt_refer(target_lo,1);
      }
      no_ds_br = 1;
      break;
    case 1:/* btnez */
      IADD64(pch, pcl, 0L, 2L, &dst_hi, &dst_lo, &cy);
      if(decIMMD&0x80){
	tmp_lo = (ulong)((0xffffff00|decIMMD)<<1);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(decIMMD<<1);
	tmp_hi = 0L;
      }
      get_gr(24, &wrk_hi, &wrk_lo);
      if((wrk_hi|wrk_lo)!=0L){
	IADD64(dst_hi, dst_lo, tmp_hi, tmp_lo, &target_hi, &target_lo, &cy);
	bt_refer(target_lo,0);
      }
      else{
	target_hi = dst_hi;
	target_lo = dst_lo;
	bt_refer(target_lo,1);
      }
      no_ds_br = 1;
      break;
    case 2:/* swrasp */
      get_gr(29, &wrk_hi, &wrk_lo);
      get_gr(31, &rx_hi, &rx_lo);
      IADD64(wrk_hi, wrk_lo, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
      if(dst_lo&0x3){
	except = Exc_AdES;
	set_badva(dst_hi, dst_lo);
      }
      else{
	wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  put_dcache(dst_hi, dst_lo&0xfffffffcL, rx_lo);
	}
      }
      break;
    case 3:/* adjsp */
      if(decIMMD&0x80){
	tmp_lo = (ulong)((0xffffff00|decIMMD)<<3);
	tmp_hi = 0xffffffffL;
      }
      else{
	tmp_lo = (ulong)(decIMMD<<3);
	tmp_hi = 0L;
      }
      get_gr(29, &wrk_hi, &wrk_lo);
      IADD64(wrk_hi, wrk_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
      set_gr(29, sign_extend(dst_lo), dst_lo);
      break;
    case 4:/* svrs */
      do_save_restore(0,insn,32);
      break;
    case 5:/* mov32r */
      wrk_lo = (((decIMMD>>5)&7)|(decIMMD&0x18))&0x1f;
      get_gr(mips16_reg_get(decIMMD&0x7), &dst_hi, &dst_lo);
      set_gr(wrk_lo, dst_hi, dst_lo);
      break;
    case 6:
      except = Exc_RI;
      break;
    default:/* movr32 */
      get_gr(decIMMD5, &dst_hi, &dst_lo);
      set_gr(decRY, dst_hi, dst_lo);
    }
    break;
  case 015:/* li */
    set_gr(decRX, 0L, (ulong)decIMMD);
    break;
  case 016:/* cmpi */
    dst_lo = rx_lo^((ulong)decIMMD);
    dst_hi = rx_hi;
    set_gr(24, dst_hi, dst_lo);
    break;
  case 017:/* sd */
    if(inst64_en){
      IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
      if(dst_lo&7L){
    	except = Exc_AdES;
     	set_badva(dst_hi, dst_lo);
      }
      else{
     	wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
       	if(except!=Exc_NONE)
     	  set_badva(dst_hi, dst_lo);
       	if(except==Exc_NONE){
    	  wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	  put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	  put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 020:/* lb */
    IADD64(rx_hi, rx_lo, 0L, (ulong)decIMMD5, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3){
      case 0:
	break;
      case 1:
	wrk_lo = wrk_lo>> 8;
	break;
      case 2:
	wrk_lo = wrk_lo>>16;
	break;
      case 3:
	wrk_lo = wrk_lo>>24;
	break;
      }
      if(wrk_lo&0x80L){
	dst_lo = 0xffffff00L|(wrk_lo&0x000000ffL);
	dst_hi = 0xffffffffL;
      }
      else{
	dst_lo = (wrk_lo&0x000000ffL);
	dst_hi = 0L;
      }
      set_gr(decRY, dst_hi, dst_lo);
    }
    break;
  case 021:/* lh */
    IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<1), &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3){
	case 0:
	  break;
	case 1:
	  break;
	case 2:
	  wrk_lo = wrk_lo>>16;
	  break;
	case 3:
	  wrk_lo = wrk_lo>>16;
	  break;
	}
	if(wrk_lo&0x8000L){
	  dst_lo = 0xffff0000L|(wrk_lo&0x0000ffffL);
	  dst_hi = 0xffffffffL;
	}
	else{
	  dst_lo = (wrk_lo&0x0000ffffL);
	  dst_hi = 0L;
	}
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    break;
  case 022:/* lwsp */
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRX, wrk_hi, wrk_lo);
      }
    }
    break;
  case 023:/* lw */
    IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRY, wrk_hi, wrk_lo);
      }
    }
    break;
  case 024:/* lbu */
    IADD64(rx_hi, rx_lo, 0L, (ulong)decIMMD5, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3){
      case 0:
	break;
      case 1:
	wrk_lo = wrk_lo>> 8;
	break;
      case 2:
	wrk_lo = wrk_lo>>16;
	break;
      case 3:
	wrk_lo = wrk_lo>>24;
	break;
      }
      dst_lo = (wrk_lo&0x000000ffL);
      dst_hi = 0L;
      set_gr(decRY, dst_hi, dst_lo);
    }
    break;
  case 025:/* lhu */
    IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<1), &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3){
	case 0:
	  break;
	case 1:
	  break;
	case 2:
	  wrk_lo = wrk_lo>>16;
	  break;
	case 3:
	  wrk_lo = wrk_lo>>16;
	  break;
	}
	dst_lo = (wrk_lo&0x0000ffffL);
	dst_hi = 0L;
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    break;
  case 026:/* lwpc */
    if(delay_slot)
      IADD64(EXPCH, EXPCL&0xfffffffcL, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
    else
      IADD64(pch, pcl&0xfffffffcL, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdEL;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	if(wrk_lo&0x80000000L){
	  wrk_hi = 0xffffffffL;
	}
	else{
	  wrk_hi = 0L;
	}
	set_gr(decRX, wrk_hi, wrk_lo);
      }
    }
    break;
  case 027:/* lwu */
    if(inst64_en){
      IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
      if(dst_lo&3L){
	except = Exc_AdEL;
 	  set_badva(dst_hi, dst_lo);
     }
      else{
	wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffffcL, &except);
	if(except!=Exc_NONE)
	  set_badva(dst_hi, dst_lo);
	if(except==Exc_NONE){
	  set_gr(decRY, 0L, wrk_lo);
	}
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  case 030:/* sb */
    IADD64(rx_hi, rx_lo, 0L, (ulong)decIMMD5, &dst_hi, &dst_lo, &cy);
    wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
    if(except!=Exc_NONE)
      set_badva(dst_hi, dst_lo);
    if(except==Exc_NONE){
      switch(dst_lo&0x3L){
      case 0:
	wrk_lo = (ry_lo&0x000000ffL)|(wrk_lo&0xffffff00L);
	break;
      case 1:
	wrk_lo = ((ry_lo&0x000000ffL)<<8)|(wrk_lo&0xffff00ffL);
	break;
      case 2:
	wrk_lo = ((ry_lo&0x000000ffL)<<16)|(wrk_lo&0xff00ffffL);
	break;
      case 3:
	wrk_lo = ((ry_lo&0x000000ffL)<<24)|(wrk_lo&0x00ffffffL);
	break;
      }
      put_dcache(dst_hi, dst_lo&0xfffffffcL, wrk_lo);
    }
    break;
  case 031:/* sh */
    IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<1), &dst_hi, &dst_lo, &cy);
    if(dst_lo&1L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	switch(dst_lo&0x3L){
	case 0:
	  wrk_lo = (ry_lo&0x0000ffffL)|(wrk_lo&0xffff0000L);
	  break;
	case 1:
	  wrk_lo = (ry_lo&0x0000ffffL)|(wrk_lo&0xffff0000L);
	  break;
	case 2:
	  wrk_lo = ((ry_lo&0x0000ffffL)<<16)|(wrk_lo&0x0000ffffL);
	  break;
	case 3:
	  wrk_lo = ((ry_lo&0x0000ffffL)<<16)|(wrk_lo&0x0000ffffL);
	  break;
	}
	put_dcache(dst_hi, dst_lo&0xfffffffcL, wrk_lo);
      }
    }
    break;
  case 032:/* swsp */
    get_gr(29, &ry_hi, &ry_lo);
    IADD64(ry_hi, ry_lo, 0L, (ulong)(decIMMD<<2), &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	put_dcache(dst_hi, dst_lo&0xfffffffcL, rx_lo);
      }
    }
    break;
  case 033:/* sw */
    IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
    if(dst_lo&3L){
      except = Exc_AdES;
      set_badva(dst_hi, dst_lo);
    }
    else{
      wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffffcL, &except);
      if(except!=Exc_NONE)
	set_badva(dst_hi, dst_lo);
      if(except==Exc_NONE){
	put_dcache(dst_hi, dst_lo&0xfffffffcL, ry_lo);
      }
    }
    break;
  case 034:/* RRR */
    switch(decFUNC){
    case 0:/* daddu */
      if(inst64_en){
	IADD64(rx_hi, rx_lo, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRZ, dst_hi, dst_lo);
      }
      else{
	except = Exc_RI;
      }
      break;
    case 1:/* addu  */
      IADD64(rx_hi, rx_lo, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
      set_gr(decRZ, sign_extend(dst_lo), dst_lo);
      break;
    case 2:/* dsubu */
      if(inst64_en){
	ISUB64(rx_hi, rx_lo, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRZ, dst_hi, dst_lo);
      }
      else{
	except = Exc_RI;
      }
      break;
    default:/* subu */
      ISUB64(rx_hi, rx_lo, ry_hi, ry_lo, &dst_hi, &dst_lo, &cy);
      set_gr(decRZ, sign_extend(dst_lo), dst_lo);
    }
    break;
  case 035:/* RR */
    exec_mips16_RR(decRR,decRX,decRY,decSA,(ulong)insn);
    break;
  case 036:/* extend */
    extend_flag = 1;
    extend_code = insn;
    EXPCH = PCH;
    EXPCL = PCL;
    break;
  case 037:/* I64 */
    if(inst64_en){
      switch((insn>>8)&7){
      case 0:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdEL;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    set_gr(decRY, wrk_hi, wrk_lo);
	  }
	}
	break;
      case 1:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdES;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	  }
	}
	break;
      case 2:
	get_gr(29, &rx_hi, &rx_lo);
	get_gr(31, &ry_hi, &ry_lo);
	IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD<<3), &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdES;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcaches(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcaches(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+0, ry_lo);
	    put_dcache(dst_hi, (dst_lo&0xfffffff8L)+4, ry_hi);
	  }
	}
	break;
      case 3:
	if(decIMMD&0x80){
	  tmp_lo = (ulong)((0xffffff00|decIMMD)<<3);
	  tmp_hi = 0xffffffffL;
	}
	else{
	  tmp_lo = (decIMMD<<3);
	  tmp_hi = 0L;
	}
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(29, dst_hi, dst_lo);
	break;
      case 4:
	if(delay_slot)
	  IADD64(EXPCH, EXPCL&0xfffffff8L, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
	else
	  IADD64(pch, pcl&0xfffffff8L, 0L, (ulong)(decIMMD5<<3), &dst_hi, &dst_lo, &cy);
	if(dst_lo&7L){
	  except = Exc_AdEL;
	  set_badva(dst_hi, dst_lo);
	}
	else{
	  wrk_lo = get_dcachel(dst_hi, dst_lo&0xfffffff8L, &except);
	  if(except!=Exc_NONE)
	    set_badva(dst_hi, dst_lo);
	  if(except==Exc_NONE){
	    wrk_hi = get_dcachel(dst_hi, (dst_lo&0xfffffff8L)+4, &except);
	    set_gr(decRY, wrk_hi, wrk_lo);
	  }
	}
	break;
      case 5:
	if(decIMMD5&0x10){
	  tmp_lo = (ulong)(0xffffffe0|decIMMD5);
	  tmp_hi = 0xffffffffL;
	}
	else{
	  tmp_lo = (ulong)decIMMD5;
	  tmp_hi = 0L;
	}
	IADD64(ry_hi, ry_lo, tmp_hi, tmp_lo, &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
	break;
      case 6:
	if(delay_slot)
	  IADD64(EXPCH, EXPCL&0xfffffffcL, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
	else
	  IADD64(pch, pcl&0xfffffffcL, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
	break;
      default:
	get_gr(29, &rx_hi, &rx_lo);
	IADD64(rx_hi, rx_lo, 0L, (ulong)(decIMMD5<<2), &dst_hi, &dst_lo, &cy);
	set_gr(decRY, dst_hi, dst_lo);
      }
    }
    else{
      except = Exc_RI;
    }
    break;
  }
  delay_slot = br_inst;
  if(delay_slot){
    EXPCH = PCH;
    EXPCL = PCL;
  }
}
