/*************************************************/
/* All rights reserved by Akira Nakamori. This   */
/* program must be uesed solely for the purpose  */ 
/* for which it was furnished by Akira Nakamori. */
/*                                               */
/*     Copyright (C) Akira Nakamori 2004         */
/*************************************************/
typedef unsigned long ulong;
typedef unsigned int  uint;
/*
  misc
*/
#include <string.h>
/*
  simips.c
*/
#define R4300 0
#define R4100 1
/*
  mem.c
*/
#define INPUTFILE "__mips.inp"
#define MAXINPBUF 100
#define MAXPAGENUM 20
void io_init(void);
void mem_init(void);
ulong get_word(ulong addr);
void  put_word(ulong addr, ulong data);
void  put_half(ulong addr, ulong data);
void  put_byte(ulong addr, ulong data);
ulong get_pword(ulong addr);
void  put_pword(ulong addr, ulong data);
void  mem_dump(ulong start, ulong end, int unit);
/*
  asm.c
*/
long gen_val(char *num);
int regnum( char *reg);
/*
  asm16.c
*/
/*
  dis.c
*/
void dismips(char *base, char *num);
void dismips16(char *base, char *num);
void dis_one(ulong addrh, ulong addrl);
void dis16_one(ulong addrh, ulong addrl);
/*
  load.c
*/
void loadi(char *fname, char *base);
void loads(char *fname, char *base);
void loadm(char *fname);
void loade(char *fname);
/*
  arith.c
*/
void IADD64(ulong a1, ulong a0, ulong b1, ulong b0,
	    ulong *s1, ulong *s0, int *cy);
void ISUB64(ulong a1, ulong a0, ulong b1, ulong b0,
	    ulong *s1, ulong *s0, int *cy);
void NEG128(ulong a3, ulong a2, ulong a1, ulong a0,
            ulong *b3, ulong *b2, ulong *b1, ulong *b0);
void UMUL32(ulong a, ulong b, ulong *hi, ulong *lo);
void UMUL64(ulong a1, ulong a0, ulong b1, ulong b0,
            ulong *c3, ulong *c2, ulong *c1, ulong *c0);
void UDIV32(ulong s, ulong t, ulong *q, ulong *r);
void UDIV64(ulong sh, ulong sl, ulong th, ulong tl,
            ulong *qh, ulong *ql, ulong *rh, ulong *rl);
void FDIV64(ulong sh, ulong sl, ulong th, ulong tl,
            ulong *qh, ulong *ql, ulong *rh, ulong *rl,
	    int cnt);
void FSQRT64(ulong x1, ulong x0, ulong *y1, ulong *y0, ulong *r);
void FSQRT32(ulong s, ulong *d, ulong *r);
void RSHIFTS(ulong ihi, ulong ilo, int cnt,
             ulong *ohi, ulong *olo);
void RSHIFTL(ulong ihi, ulong ilo, int cnt,
            ulong *ohi, ulong *olo);
void RSHIFTA(ulong ihi, ulong ilo, int cnt,
            ulong *ohi, ulong *olo);
void LSHIFT(ulong ihi, ulong ilo, int cnt,
            ulong *ohi, ulong *omd, ulong *olo);
int CLZ32(ulong a);
int CLZ64(ulong ah, ulong al);
int CLO32(ulong a);
int CLO64(ulong ah, ulong al);
void CMP64(ulong sh, ulong sl, ulong th, ulong tl, int *lt, int *eq);
void ACMP64(ulong sh, ulong sl, ulong th, ulong tl, int *lt, int *eq);
void UCMP64(ulong sh, ulong sl, ulong th, ulong tl, int *lt, int *eq);
void INEG64(ulong sh, ulong sl, ulong *dh, ulong *dl);
void IADD96(ulong s2, ulong s1, ulong s0,
            ulong t2, ulong t1, ulong t0,
            ulong *d2, ulong *d1, ulong *d0);
void UDIV(ulong sh, ulong sl, ulong th, ulong tl,
            ulong *qh, ulong *ql, ulong *rh, ulong *rl, int cnt);
/*
  cpu.c
*/
void set_fcr31(ulong lo);
void set_pc(ulong hi, ulong lo);
void get_pc(ulong *hi, ulong *lo);
void get_gr(int no, ulong *hi, ulong *lo);
void set_gr(int no, ulong hi, ulong lo);
void get_hi(ulong *hi, ulong *lo);
void set_hi(ulong hi, ulong lo);
void get_lo(ulong *hi, ulong *lo);
void set_lo(ulong hi, ulong lo);
void execute(void);
ulong sign_extend(ulong a);
void cpu_dump(void);
void fpu_dump(void);
void get_fr64(int no, ulong *hi, ulong *lo);
ulong get_fr32(int no);
void set_fr64(int no, ulong hi, ulong lo);
void set_fr32(int no, ulong d);
void init_cpu(void);
/*
  cp0.c
*/
#define C0_Index    0
#define C0_Random   1
#define C0_EntryLo  2             /* R2000/R3000               */
#define C0_EntryLo0 2
#define C0_EntryLo1 3
#define C0_Context  4
#define C0_PageMask 5
#define C0_Wired    6
#define C0_Error    7             /* R6000                     */
#define C0_BadVAddr 8
#define C0_Count    9
#define C0_ASID     10            /* R6000                     */
#define C0_EntryHi  10
#define C0_Compare  11
#define C0_SR       12
#define C0_Cause    13
#define C0_EPC      14
#define C0_PRId     15
#define C0_Config   16
#define C0_LLAddr   17
#define C0_WatchLo  18
#define C0_WatchHi  19
#define C0_XContext 20
#define C0_ECC      26             /* R4000                     */
#define C0_PErr     26             /* R4200                     */
#define C0_CacheErr 27
#define C0_TagLo    28
#define C0_TagHi    29
#define C0_ErrorEPC 30
#define Exc_Int     (0<<2)         /* Interrupt.                */
#define Exc_Mod     (1<<2)         /* TLB Modification.         */
#define Exc_TLBL    (2<<2)         /* TLB (Load or Instruction).*/
#define Exc_TLBS    (3<<2)         /* TLB (Store).              */
#define Exc_AdEL    (4<<2)         /* Address Error (Load / IF).*/
#define Exc_AdES    (5<<2)         /* Address Error (Store).    */
#define Exc_IBE     (6<<2)         /* IF Bus Error.             */
#define Exc_DBE     (7<<2)         /* Load / Store Bus Error.   */
#define Exc_Sys     (8<<2)         /* Syscall Instruction.      */
#define Exc_Bp      (9<<2)         /* Breakpoint Instruction.   */
#define Exc_RI     (10<<2)         /* Reserved Instruction.     */
#define Exc_CpU    (11<<2)         /* Coprocessor Unusable.     */
#define Exc_Ov     (12<<2)         /* Overflow.                 */
#define Exc_Tr     (13<<2)         /* Trap Instruction.         */
#define Exc_VCEI   (14<<2)         /* Virtual Coherency Inst.   */
#define Exc_FPE    (15<<2)         /* Floating Point.           */
#define Exc_C2E    (16<<2)         /* Coprocessor 2.            */
#define Exc_MDMX   (22<<2)         /* MDMX.                     */
#define Exc_WATCH  (23<<2)         /* WatchHi / WatchLo Address.*/
#define Exc_MCheck (24<<2)         /* Machine Check.            */
#define Exc_VCED   (31<<2)         /* Virtual Coherency Data.   */
#define Exc_TLBML  100             /* TLB Miss (Load or Instr). */
#define Exc_TLBMS  101             /* TLB Miss (Store).         */
#define Exc_NONE   256             /* No Exceptions.            */
#define READ       0
#define WRITE      1
#define NTLB       48              /* no of TLB Entries. */
void  set_badva(ulong hi, ulong lo);
ulong get_cause(void);
void  set_cause(ulong v);
ulong get_context(void);
void  set_context(ulong v);
void  get_xcontext(ulong *hi, ulong *lo);
void  set_xcontext(ulong hi, ulong lo);
void  mtc0(int regno, ulong value);
ulong mfc0(int regno);
void  dmtc0(int regno, ulong hi, ulong lo);
void  dmfc0(int regno, ulong *hi, ulong *lo);
void  tlbwi(void);
void  tlbwr(void);
ulong va2pa(ulong va_hi, ulong va_lo, int *c, int *d, int *v, int *hit);
ulong addchk(ulong hi, ulong lo, int *map, int *ca, int *err);
ulong addr_trans(ulong hi, ulong lo, int type, int *ca, int *err);
void  tlbr(void);
void  tlbp(void);
void  update_random(void);
void  init_cp0(void);
ulong get_lastpa(void);
void  cp0_dump(void);
void update_count(void);
int int_check(void);
/*
   cache.c
*/
#define ICSIZE  0x8000  /* 32K Byte */
#define DCSIZE  0x4000  /* 16K Byte */
#define ICLINE  4       /* 4 Word/Line */
#define DCLINE  4       /* 4 Word/Line */
#define ICLINES (ICSIZE/(1<<ICLINE))
#define DCLINES (DCSIZE/(1<<DCLINE))
#define CFG_IS  5 /* ICLINES = 0x800 */
#define CFG_IL  3 /* ICLINE  = 16 bytes */
#define CFG_IA  0 /* Direct mapped */
#define CFG_DS  4 /* DCLINES = 0x400 */
#define CFG_DL  3 /* DCLINE  = 16 bytes */
#define CFG_DA  0 /* Direct mapped */
void init_cache(void);
ulong ic_read(ulong va, ulong pa);
ulong dc_read(ulong va, ulong pa);
void  dc_write(ulong va, ulong pa, ulong data);
ulong get_icache(ulong va_hi, ulong va_lo, int *err);
ulong get_dcachel(ulong va_hi, ulong va_lo, int *err);
ulong get_dcaches(ulong va_hi, ulong va_lo, int *err);
void  put_dcache(ulong va_hi, ulong va_lo, ulong data);
void  Index_Inv_I(ulong va_hi, ulong va_lo, int *err);
void  Index_WB_Inv_D(ulong va_hi, ulong va_lo, int *err);
void  Index_Load_Tag_I(ulong va_hi, ulong va_lo, int *err);
void  Index_Load_Tag_D(ulong va_hi, ulong va_lo, int *err);
void  Index_Store_Tag_I(ulong va_hi, ulong va_lo, int *err);
void  Index_Store_Tag_D(ulong va_hi, ulong va_lo, int *err);
void  Create_Dirty_D(ulong va_hi, ulong va_lo, int *err);
void  Hit_Inv_I(ulong va_hi, ulong va_lo, int *err);
void  Hit_Inv_D(ulong va_hi, ulong va_lo, int *err);
void  Hit_WB_Inv_D(ulong va_hi, ulong va_lo, int *err);
void  Fill_I(ulong va_hi, ulong va_lo, int *err);
void  Hit_WB_I(ulong va_hi, ulong va_lo, int *err);
void  Hit_WB_D(ulong va_hi, ulong va_lo, int *err);
/*
  fpu.c
*/
#define opADD  0
#define opSUB  1
#define opMUL  2
#define opDIV  3
#define opSQRT 4
#define opABS  5
#define opMOV  6
#define opNEG  7
#define opROUND_L 8
#define opTRUNC_L 9
#define opCEIL_L  10
#define opFLOOR_L 11
#define opROUND_W 12
#define opTRUNC_W 13
#define opCEIL_W  14
#define opFLOOR_W 15
#define opMOVT    17
#define opMOVF    17
#define opMOVCF   17
#define opMOVZ    18
#define opMOVN    19
#define opRECIP   21
#define opRSQRT   22
#define opCVT_S   32
#define opCVT_PU  32
#define opCVT_D   33
#define opCVT_W   36
#define opCVT_L   37
#define opCVT_PS  38
#define opCVT_PL  40
#define opPLL     44
#define opPLU     45
#define opPUL     46
#define opPUU     47
#define opCMP_F   48
#define opCMP_UN  49
#define opCMP_EQ  50
#define opCMP_UEQ 51
#define opCMP_OLT 52
#define opCMP_ULT 53
#define opCMP_OLE 54
#define opCMP_ULE 55
#define opCMP_SF  56
#define opCMP_NGLE 57
#define opCMP_SEQ 58
#define opCMP_NGL 59
#define opCMP_LT  60
#define opCMP_NGE 61
#define opCMP_LE  62
#define opCMP_NGT 63
#define opPREFX   15
#define opMADD_S  32
#define opMADD_D  33
#define opMSUB_S  40
#define opMSUB_D  41
#define opNMADD_S 48
#define opNMADD_D 49
#define opNMSUB_S 56
#define opNMSUB_D 57
#define fmtS  16
#define fmtD  17
#define fmtW  20
#define fmtL  21
#define fmtPS 22
#define rmRN  0
#define rmRZ  1
#define rmRP  2
#define rmRM  3
void FPU(int   op,               /* operation */
         int   fmt,              /* format    */
	 int   rm,               /* rounding mode */
         int   fs_bit,           /* FS bit    */
         ulong fsh,  ulong fsl,  /* source    */
         ulong fth,  ulong ftl,  /* target    */
         ulong *fdh, ulong *fdl, /* destination */
         int *e,   /* Unimplement Operation */
         int *v,   /* Invalid Operation     */
         int *z,   /* Divide by Zero        */
         int *o,   /* Overflow              */
         int *u,   /* Underflow             */
         int *i,   /* Inexact Operation     */
         int *cmp, /* Compare?              */
         int *cc   /* Condition Code        */
);
void FPUX(int   op,               /* operation */
	 int   rm,               /* rounding mode */
         int   fs_bit,           /* FS bit    */
         ulong fsh,  ulong fsl,  /* source    */
         ulong fth,  ulong ftl,  /* target    */
	 ulong frh,  ulong frl,  /* rest?     */
         ulong *fdh, ulong *fdl, /* destination */
         int *e,   /* Unimplement Operation */
         int *v,   /* Invalid Operation     */
         int *z,   /* Divide by Zero        */
         int *o,   /* Overflow              */
         int *u,   /* Underflow             */
         int *i   /* Inexact Operation     */
);
void PS_FPU(int   op,               /* operation */
	 int   rm,               /* rounding mode */
         int   fs_bit,           /* FS bit    */
         ulong fsh,  ulong fsl,  /* source    */
         ulong fth,  ulong ftl,  /* target    */
         ulong *fdh, ulong *fdl, /* destination */
         int *e,   /* Unimplement Operation */
         int *v,   /* Invalid Operation     */
         int *z,   /* Divide by Zero        */
         int *o,   /* Overflow              */
         int *u,   /* Underflow             */
         int *i,   /* Inexact Operation     */
         int *cmp, /* Compare?              */
         int *cc   /* Condition Code        */
);
void PS_FPUX(int   op,               /* operation */
	 int   rm,               /* rounding mode */
         int   fs_bit,           /* FS bit    */
         ulong fsh,  ulong fsl,  /* source    */
         ulong fth,  ulong ftl,  /* target    */
	 ulong frh,  ulong frl,  /* rest?     */
         ulong *fdh, ulong *fdl, /* destination */
         int *e,   /* Unimplement Operation */
         int *v,   /* Invalid Operation     */
         int *z,   /* Divide by Zero        */
         int *o,   /* Overflow              */
         int *u,   /* Underflow             */
         int *i   /* Inexact Operation     */
);
/*
  cpu16.c
*/
void execute16(ulong pch, ulong pcl);
void init_cpu16(void);
/*
  statictic.c
*/
void bt_clear(void);
void bt_init(void);
void bt_lru_upd(int entry);
void bt_refer(ulong addr, int taken);
void bt_report(void);
void set_bt(int entry);
void ic_report(void);
void dc_report(void);
