#include <stdio.h>
#include <stdlib.h>
#include "define.h"

static FILE *fp;

static int hex(int c)
{
  if((c >= '0') && (c <= '9')) return ( c - '0');
  if((c >= 'A') && (c <= 'F')) return ((c - 'A') + 10);
  if((c >= 'a') && (c <= 'f')) return ((c - 'a') + 10);
  return 0;
}
/*
static void put_byte(long addr, int byte)
{
  ulong word;

  byte &= 0xff;
  word = get_word(addr);
  switch(addr&3){
  case 0:
    word = (word&0xffffff00)|byte;
    break;
  case 1:
    word = (word&0xffff00ff)|(byte<<8);
    break;
  case 2:
    word = (word&0xff00ffff)|(byte<<16);
    break;
  case 3:
    word = (word&0x00ffffff)|(byte<<24);
    break;
  }
  put_word(addr,word);
}
*/
/*
  Intel Hex Load
*/
void loadi(char *fname, char *base)
{

  int eof, i;
  int ch;

  int	reclen, adofset, rectyp;
  long  adbase, address;
  int	byte;

  if(*base!='\0')
    adbase = (long)gen_val(base);
  else
    adbase = 0;
  fp = fopen(fname,"r");
  if(fp==NULL){
    fprintf(stderr,"cannot open %s\n",fname);
    return;
  }
  eof = 0;
  while(!eof){
    while((ch=getc(fp)) != ':')
      if(ch==EOF){
	fclose(fp);
	return;
      }
    reclen = hex( getc(fp) );
    reclen = reclen * 16 + hex( getc(fp) );
    adofset = hex( getc(fp) );
    adofset = adofset * 16 + hex( getc(fp) );
    adofset = adofset * 16 + hex( getc(fp) );
    adofset = adofset * 16 + hex( getc(fp) );
    rectyp = hex( getc(fp) );
    rectyp = rectyp * 16 + hex( getc(fp) );
    switch( rectyp ){
    case 0x00: /* data record */
      address = adbase + adofset;
      for(i=0; i<reclen ; i++){
	byte = hex( getc(fp) );
	byte = byte * 16 + hex( getc(fp) );
	put_byte(address+i, byte);
      }
      break;
    case 0x01:  /* end of file */
      fclose( fp );
      eof = 1;
      break;
    case 0x02:  /* extended address code */
      address = hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      adbase = address << 4;
      break;
    case 0x03:  /* no meaning(start address) */
      break;
    case 0x04:  /* upper 16bit for 32bit linear addr */
      address = hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      adbase = address << 16;
      break;
    case 0x05:  /* no meaning(start address for 32bit linear */
      break;
    case 0x32:  /* extended 32-bit address code(original) */
      address = hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      adbase = address;
      break;
    }	
  }
}

/*
  Motorola S Record Load

S0
     Header record for each block of S records which may contain descriptive
     information identifying the following block of S records. The address
     field is typically zeros. The code/data field of an S0 record typically
     contains a "hexified" ASCII string.
S1
     Code or data record containing a 2-byte address (4 hex digit address).
S2
     Code or data record containing a 3-byte address (6 hex digit address).
S3
     Code or data record containing a 4-byte address (8 hex digit address).
S5
     Count record containing the number of S1, S2, and S3 records
     transmitted in a block. The count appears in the address field, and
     there is no code/data field (I never saw this actually used).
S7
     Termination record for a block of S records. A 4-byte address contains
     the address where execution starts. There is no code/data field.
S8
     Termination record for a block of S records. A 3-byte address contains
     the address where execution starts. There is no code/data field.
S9
     Termination record for a block of S records. A 2-byte address contains
     the address where execution starts. There is no code or data field.
*/
void loads(char *fname, char *base)
{

  int eof, i;
  int ch;

  int	reclen;
  int   addlen;
  long  adbase, address;
  int	byte;
  int   load;

  if(*base!='\0')
    adbase = (long)gen_val(base);
  else
    adbase = 0;
  fp = fopen(fname,"r");
  if(fp==NULL){
    fprintf(stderr,"cannot open %s\n",fname);
    return;
  }
  eof = 0;
  while(!eof){
    while((ch=getc(fp)) != 'S')
      if(ch==EOF){
	fclose(fp);
	return;
      }
    switch( getc(fp) ){
    case '1':
      addlen = 2;
      load   = 1;
      break;
    case '2':
      addlen = 3;
      load   = 1;
      break;
    case '3':
      addlen = 4;
      load   = 1;
      break;
    case '7':
    case '8':
    case '9':
      eof = 1;
      load = 0;
      fclose(fp);
      break;
    default:
      load = 0;
    }
    if(load){
      reclen = hex( getc(fp) );
      reclen = reclen * 16 + hex( getc(fp) );
      address = hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      address = address * 16 + hex( getc(fp) );
      if(addlen>2){
	address = address * 16 + hex( getc(fp) );
	address = address * 16 + hex( getc(fp) );
	if(addlen>3){
	  address = address * 16 + hex( getc(fp) );
	  address = address * 16 + hex( getc(fp) );
	}
      }
      address += adbase;
      for(i=0; i<(reclen-addlen); i++){
	byte = hex( getc(fp) );
	byte = byte * 16 + hex( getc(fp) );
	put_byte(address+i, byte);
      }
    }
  }
}

static char Line[1024];

void loadm(char *fname)
{
  int   eof;
  ulong addr, data;

  fp = fopen(fname,"r");
  if(fp==NULL){
    fprintf(stderr,"cannot open %s\n",fname);
    return;
  }
  eof = 0;
  while(!eof){
    if(fgets(Line, 1024, fp)==0){
      fclose(fp);
      eof = 1;
      continue;
    }
    if(strlen(Line)>16){ /* MIPS32 */
      sscanf(Line, "%x %x", &addr, &data);
      put_word(addr, data);
    }
    else{/* MIPS16 */
      sscanf(Line, "%x %x", &addr, &data);
      put_byte(addr+0, data&0xffL);
      put_byte(addr+1, (data>>8)&0xffL);
    }
   
  }
}

long get_dat(FILE* fp, int size)
{
  int i;
  int n;
  char ch[16];
  if(size>16)
    size = 16;
  for(i=0;i<size;i++)
    ch[i] = fgetc(fp);
  for(n=0,i=(size-1);i>=0;i--)
    n = (n<<8)|(ch[i]&0xff);
  return n;
}

typedef unsigned long  Elf32_Addr;
typedef unsigned short Elf32_Half;
typedef unsigned long  Elf32_Off;
typedef long           Elf32_Sword;
typedef unsigned long  Elf32_Word;

typedef struct {
  Elf32_Word  sh_name;
  Elf32_Word  sh_type;
  Elf32_Word  sh_flags;
  Elf32_Addr  sh_addr;
  Elf32_Off   sh_offset;
  Elf32_Word  sh_size;
  Elf32_Word  sh_link;
  Elf32_Word  sh_info;
  Elf32_Word  sh_addralign;
  Elf32_Word  sh_entsize;
} Elf32_Shdr;

typedef struct elf64_shdr {
  unsigned int       sh_name;/* Section name, index in string tbl */
  unsigned int       sh_type;/* Type of section */
  unsigned long long sh_flags;/* Miscellaneous section attributes */
  unsigned long long sh_addr;/* Section virtual addr at execution */
  unsigned long long sh_offset;/* Section file offset */
  unsigned long long sh_size;/* Size of section in bytes */
  unsigned int       sh_link;/* Index of another section */
  unsigned int       sh_info;/* Additional section information */
  unsigned long long sh_addralign;/* Section alignment */
  unsigned long long sh_entsize;/* Entry size if section holds table */
} Elf64_Shdr;

typedef struct elf32_sym{
  Elf32_Word    st_name;
  Elf32_Addr    st_value;
  Elf32_Word    st_size;
  unsigned char st_info;
  unsigned char st_other;
  Elf32_Half    st_shndx;
} Elf32_Sym;

typedef struct elf64_sym {
  unsigned int   st_name;/* Symbol name, index in string tbl */
  unsigned char  st_info;/* Type and binding attributes */
  unsigned char  st_other;/* No defined meaning, 0 */
  unsigned short st_shndx;/* Associated section index */
  unsigned long long st_value;/* Value of the symbol */
  unsigned long long st_size;/* Associated symbol size */
} Elf64_Sym;

int elf_entry;
int globl_ptr;

void loade(char *fname)
{
  int arch_64;
  int endi_big;

/* ELF Header */
  int e_type;
  int e_machine;
  int e_version;
  int e_entry;
  int e_phoff;
  int e_shoff;
  int e_flags;
  int e_ehsize;
  int e_phentsize;
  int e_phnum;
  int e_shentsize;
  int e_shnum;
  int e_shstrndx;
/* Program Header */
  int p_type;
  int p_offset;
  int p_vaddr;
  int p_paddr;
  int p_filesz;
  int p_memsz;
  int p_flags;
  int p_align;
  int m0,m1,m2,m3;
  int ei_class;
  int ei_data;
  int i,j;
  int ph_off;

/* Section Header */
  int  sh_name;
  int  sh_type;
  int  sh_flags;
  int  sh_addr;
  int  sh_offset;
  int  sh_size;
  int  sh_link;
  int  sh_info;
  int  sh_addralign;
  int  sh_entsize;

/* Symbol Table */
  int   st_name;
  int   st_value;
  int   st_size;
  char  st_info;
  char  st_other;
  short st_shndx;

  int symtab_off;
  int symtab_siz;
  int strtab_off[10];
  int strtab_siz[10];
  char *str[10];
  int strs=0;

  fp = fopen(fname,"rb");
  if(fp==NULL){
    fprintf(stderr,"cannot open %s\n",fname);
    return;
  }
  m0 = get_dat(fp,1);
  m1 = get_dat(fp,1);
  m2 = get_dat(fp,1);
  m3 = get_dat(fp,1);
  ei_class = get_dat(fp,1);
  ei_data  = get_dat(fp,1);
  if(m0!=0x7f){
    fprintf(stderr,"not ELF file %s!\n",fname);
    fclose(fp);
    return;
  }
  if(m1!='E'){
    fprintf(stderr,"not ELF file %s!\n",fname);
    fclose(fp);
    return;
  }
  if(m2!='L'){
    fprintf(stderr,"not ELF file %s!\n",fname);
    fclose(fp);
    return;
  }
  if(m3!='F'){
    fprintf(stderr,"not ELF file %s!\n",fname);
    fclose(fp);
    return;
  }
  if(ei_class == 2)
    arch_64 = 1;
  else
    arch_64 = 0;
  if(ei_data == 2)
    endi_big = 1;
  else
    endi_big = 0;
/*
  printf("arch_64=%d endi_big=%d\n",arch_64, endi_big);
*/
  fseek(fp, 16, SEEK_SET);
  if(arch_64){
    e_type      = get_dat(fp,2);
    e_machine   = get_dat(fp,2);
    e_version   = get_dat(fp,4);
    e_entry     = get_dat(fp,4);
    fseek(fp, 4, SEEK_CUR);
    e_phoff     = get_dat(fp,4);
    fseek(fp, 4, SEEK_CUR);
    e_shoff     = get_dat(fp,4);
    fseek(fp, 4, SEEK_CUR);
    e_flags     = get_dat(fp,4);
    e_ehsize    = get_dat(fp,2);
    e_phentsize = get_dat(fp,2);
    e_phnum     = get_dat(fp,2);
    e_shentsize = get_dat(fp,2);
    e_shnum     = get_dat(fp,2);
    e_shstrndx  = get_dat(fp,2);
  }
  else{
    e_type      = get_dat(fp,2);
    e_machine   = get_dat(fp,2);
    e_version   = get_dat(fp,4);
    e_entry     = get_dat(fp,4);
    e_phoff     = get_dat(fp,4);
    e_shoff     = get_dat(fp,4);
    e_flags     = get_dat(fp,4);
    e_ehsize    = get_dat(fp,2);
    e_phentsize = get_dat(fp,2);
    e_phnum     = get_dat(fp,2);
    e_shentsize = get_dat(fp,2);
    e_shnum     = get_dat(fp,2);
    e_shstrndx  = get_dat(fp,2);
  }
/*
  printf("e_type=%x\n",e_type);
  printf("e_machine=%x\n",e_machine);
  printf("e_entry=%x\n",e_entry);
  printf("e_phoff=%x\n",e_phoff);
  printf("e_shoff=%x\n",e_shoff);
  printf("e_flags=%x\n",e_flags);
  printf("e_ehsize=%x\n",e_ehsize);
  printf("e_phentsize=%x\n",e_phentsize);
  printf("e_phnum=%x\n",e_phnum);
  printf("e_shentsize=%x\n",e_shentsize);
  printf("e_shnum=%x\n",e_shnum);
  printf("e_shstrndx=%x\n",e_shstrndx);
*/
  ph_off = 0;
  for(i=0;i<e_phnum;i++){
    fseek(fp, e_phoff+ph_off, SEEK_SET);
    if(arch_64){
      p_type   = get_dat(fp,4);
      p_offset = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_vaddr  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_paddr  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_filesz = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_memsz  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_flags  = get_dat(fp,4);
      p_align  = get_dat(fp,4);
      ph_off += 52;
    }
    else{
      p_type   = get_dat(fp,4);
      p_offset = get_dat(fp,4);
      p_vaddr  = get_dat(fp,4);
      p_paddr  = get_dat(fp,4);
      p_filesz = get_dat(fp,4);
      p_memsz  = get_dat(fp,4);
      p_flags  = get_dat(fp,4);
      p_align  = get_dat(fp,4);
      ph_off += 32;
    }
    if((p_vaddr&0xc0000000)==0x80000000){
      p_paddr = p_vaddr & 0x1fffffff;
    }
    fseek(fp, p_offset, SEEK_SET);
    while(p_memsz>0){
      int ch;
/*
      printf("p_paddr=%08x p_memsz=%x\n",p_paddr,p_memsz);
*/
      ch = fgetc(fp);
      if(ch==EOF) break;
      put_byte(p_paddr, ch);
      p_paddr++;
      p_memsz--;
    }
/*
    printf("p_type=%x\n",p_type);
    printf("p_offset=%x\n",p_offset);
    printf("p_vaddr=%x\n",p_vaddr);
    printf("p_paddr=%x\n",p_paddr);
    printf("p_filesz=%x\n",p_filesz);
    printf("p_memsz=%x\n",p_memsz);
    printf("p_flags=%x\n",p_flags);
    printf("p_align=%x\n",p_align);
*/
  }
  fseek(fp, e_phoff, SEEK_SET);
  for(i=0;i<e_phnum;i++){
    if(arch_64){
      p_type   = get_dat(fp,4);
      p_flags  = get_dat(fp,4);
      p_offset = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_vaddr  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_paddr  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_filesz = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_memsz  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      p_align  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
    }
    else{
      p_type   = get_dat(fp,4);
      p_offset = get_dat(fp,4);
      p_vaddr  = get_dat(fp,4);
      p_paddr  = get_dat(fp,4);
      p_filesz = get_dat(fp,4);
      p_memsz  = get_dat(fp,4);
      p_flags  = get_dat(fp,4);
      p_align  = get_dat(fp,4);
    }
/*
    printf("p_type=%x\n",p_type);
    printf("p_offset=%x\n",p_offset);
    printf("p_vaddr=%x\n",p_vaddr);
    printf("p_paddr=%x\n",p_paddr);
    printf("p_filesz=%x\n",p_filesz);
    printf("p_memsz=%x\n",p_memsz);
    printf("p_flags=%x\n",p_flags);
    printf("p_align=%x\n",p_align);
*/
  }
  fseek(fp, e_shoff, SEEK_SET);
  symtab_off = 0;
  for(i=0;i<e_shnum;i++){
    if(arch_64){
      sh_name   = get_dat(fp,4);
      sh_type   = get_dat(fp,4);
      sh_flags  = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      sh_addr   = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      sh_offset = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      sh_size   = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      sh_link   = get_dat(fp,4);
      sh_info   = get_dat(fp,4);
      sh_addralign = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
      sh_entsize   = get_dat(fp,4);
      fseek(fp, 4, SEEK_CUR);
    }
    else{
      sh_name   = get_dat(fp,4);
      sh_type   = get_dat(fp,4);
      sh_flags  = get_dat(fp,4);
      sh_addr   = get_dat(fp,4);
      sh_offset = get_dat(fp,4);
      sh_size   = get_dat(fp,4);
      sh_link   = get_dat(fp,4);
      sh_info   = get_dat(fp,4);
      sh_addralign = get_dat(fp,4);
      sh_entsize   = get_dat(fp,4);
/*
      printf("sh_type=%x sh_size=%x sh_off=%x\n",sh_type, sh_size, sh_offset);
*/
    }
    if(sh_type==2)/* SYMTAB */{
      symtab_off = sh_offset;
      symtab_siz = sh_size;
    }
    if(sh_type==3)/* STRTAB */{
      if(strs<10){
	strtab_off[strs] = sh_offset;
	strtab_siz[strs] = sh_size;
	strs++;
      }
    }
  }
  if(symtab_off!=0){/* SYMTAB Exist! */
    int sh_size1;
    for(i=0;i<strs;i++){
      fseek(fp, strtab_off[i], SEEK_SET);
      str[i] = (char*)malloc(strtab_siz[i]);
      fread(str[i], strtab_siz[i], 1, fp);
    }
    fseek(fp, symtab_off, SEEK_SET);
    if(arch_64)
      sh_size1 = sizeof(Elf64_Sym);
    else
      sh_size1 = sizeof(Elf32_Sym);
    for(i=0; i<symtab_siz; i += sh_size1){
      if(arch_64){
	st_name  = get_dat(fp,4);
	st_info  = get_dat(fp,1);
	st_other = get_dat(fp,1);
	st_shndx = get_dat(fp,2);
	st_value = get_dat(fp,4);
	fseek(fp, 4, SEEK_CUR);
	st_size  = get_dat(fp,4);
	fseek(fp, 4, SEEK_CUR);
      }
      else{
	st_name  = get_dat(fp,4);
	st_value = get_dat(fp,4);
	st_size  = get_dat(fp,4);
	st_info  = get_dat(fp,1);
	st_other = get_dat(fp,1);
	st_shndx = get_dat(fp,2);
      }
      for(j=0;j<strs;j++){
	if((st_name<strtab_siz[j])&&(strcmp(str[j]+st_name, "main")==0)){
	  printf("main=0x%08x\n",st_value);
          elf_entry = st_value;
        }
	if((st_name<strtab_siz[j])&&(strcmp(str[j]+st_name, "_gp")==0)){
          globl_ptr = st_value;
        }
      }
    }
    for(i=0;i<strs;i++)
      free(str[i]);
  }
  fclose(fp);
}

  
