/*************************************************/
/* All rights reserved by Akira Nakamori. This   */
/* program must be uesed solely for the purpose  */ 
/* for which it was furnished by Akira Nakamori. */
/*                                               */
/*     Copyright (C) Akira Nakamori 2004         */
/*************************************************/
#include <stdio.h>
#include <signal.h>
#include "define.h"
#if 0
int exit(int n);
#endif
extern char *__version;
void asmips(char *base, FILE *fp);
void asmips16(char *base, FILE *fp);
static FILE *fp;
int ty_cpu = R4300;
int mips32_en = 1;
int m3d_en = 1;
int ps_en = 1;
int fpu_en = 1;
int no_mips4 = 0;
int ty_llsc  = 0;
int orig_en = 0;
int ver2_en = 1;
int sig_stop = 0;
static char cmd[100];
static char av1[100];
static char av2[100];
static char av3[100];
static char lin[1024];
static ulong trace_num;
static ulong da0,da1;

static int disp_inst = 1;
static int disp_cpu = 1;
static int disp_fpu = 0;
static int disp_cp0 = 0;

static ulong bp_inst0 = 0x03fffc0dL;
static ulong bp_inst1 = 0x03ffffcdL;
static int   bp_inst0_v = 1;
static int   bp_inst1_v = 1;
static char  bp_inst0_msg[256]="Break_on_Pass";
static char  bp_inst1_msg[256]="Break_on_Fail";
static int   bp_except = 0;
static char  bp_except_msg[256]="Break_on_Exception";
static ulong bp_a;
static int   bp_a_v = 0;
static char  bp_a_msg[256]="Break_on_Address";

extern int elf_entry;
extern int globl_ptr;

static void version(void)
{
  printf("********************************************************\n");
  printf("*   MIPS Architecture Simulator (%20s) *\n",__version);
  printf("********************************************************\n");
  printf("\n");
}

static void sig_get(int a)
{
  sig_stop = 1;
  signal(SIGINT, sig_get);
}

static void help(void)
{
  printf("q                        ... quit form simulator\n");
  printf("reset                    ... reset cpu\n");
  printf("t      [times]           ... trace\n");
  printf("disp   [all|cpu|cp0|fpu] ... display registers on trace\n");
  printf("nodisp [all|cpu|cp0|fpu] ... not display registers on trace\n");
  printf("a      [addr]            ... assemble\n");
  printf("a16    [addr]            ... assemble(mips16)\n");
  printf("u      [addr]            ... disassemble\n");
  printf("u16    [addr]            ... disassemble(mips16)\n");
  printf("li     fname [offset]    ... load index hex file\n");
  printf("ls     fname [offset]    ... load motorola hex file\n");
  printf("le     fname             ... load ELF file\n");
  printf("lm     fname             ... load mem image file\n");
  printf("la     fname             ... load assembler source\n");
  printf("la16   fname             ... load assembler source(mips16)\n");
  printf("r      [cpu|cp0|fpu]     ... register dump\n");
  printf("bi0    inst  msg         ... set breakpoint by instruction\n");
  printf("bi1    inst  msg         ... set breakpoint by instruction\n");
  printf("ba     addr  msg         ... set breakpoint by address\n");
  printf("m      addr  data        ... set memory value\n");
  printf("dw     addr1 addr2       ... dump memory by word\n");
  printf("dh     addr1 addr2       ... dump memory by halfword\n");
  printf("db     addr1 addr2       ... dump memory by byte\n");
  printf("h                        ... display this message\n");
  printf("\n");
}

static int white(int ch)
{
  return (ch==' ')||(ch=='\t');
}

static int eol(int ch)
{
  return (ch=='\0')||(ch=='\n')||(ch=='\r');
}

static int split(void)
{
  char *p;
  char *q;

  cmd[0] = '\0';
  av1[0] = '\0';
  av2[0] = '\0';
  av3[0] = '\0';
  p = &lin[0];
  while(white(*p))
    p++;
  if(eol(*p))
    return 0;
  q = &cmd[0];
  while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  if(eol(*p))
    return 1;
  while(white(*p))
    p++;
  if(eol(*p))
    return 1;
  q = &av1[0];
  while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  if(eol(*p))
    return 2;
  while(white(*p))
    p++;
  if(eol(*p))
    return 2;
  q = &av2[0];
    while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  if(eol(*p))
    return 3;
  while(white(*p))
    p++;
  if(eol(*p))
    return 3;
  q = &av3[0];
    while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  return 4;
}

extern ulong brk_inst;
extern int   except;
static int break_cond(void)
{
  ulong hi, lo;
  if(bp_a_v){
    get_pc(&hi, &lo);
    if(lo==bp_a){
      printf("%s\n", bp_a_msg);
      return 1;
    }
  }
  /*
  if(bp_except){
    if(except!=Exc_NONE){
      printf("%s\n", bp_except_msg);
      return 1;
    }
  }
  */
  if(bp_inst0_v){
    if(bp_inst0==brk_inst){
      printf("%s\n", bp_inst0_msg);
      return 1;
    }
  }
  if(bp_inst1_v){
    if(bp_inst1==brk_inst){
      printf("%s\n", bp_inst1_msg);
      return 1;
    }
  }
  return 0;
}

int main(void)
{
  int ac;

  signal(SIGINT, sig_get);
  version();
#if 0
  help();
#endif
  while(1){
    sig_stop = 0;
    printf("? "); fflush(stdout);
    if(fgets(lin,1024,stdin)==0)
      break;
    ac = split();
    if(ac==0)
      continue;
    if(strcmp(cmd,"q")==0){/* quit */
      break;
    }
    if(strcmp(cmd,"boot")==0){/* prepare boot code */
      /*
	bfc00000 3c018000 : lui r1,0x8000
	bfc00004 34212000 : ori r1,r1,0x2000
	bfc00008 00200008 : jr  r1
	bfc0000c 00000000 : nop
	*/
      put_pword(0x1fc00000L, 0x3c018000L);
      put_pword(0x1fc00004L, 0x34212000L);
      put_pword(0x1fc00008L, 0x00200008L);
      put_pword(0x1fc0000cL, 0x00000000L);
    }
    if(strcmp(cmd,"boot16")==0){/* modify boot code for mips16 */
      ulong code;
      code = 0x37390000L | (elf_entry&0xffff)|1L;
      put_pword(0x1fc0001cL, code);
    }
    if(strcmp(cmd,"input0")==0){/* input #0 0x0f010000 */
      put_pword(0x1fc003b0L, 0x375a0020L);
    }
    if(strcmp(cmd,"input1")==0){/* input #0 0x0f010010 */
      put_pword(0x1fc003b0L, 0x375a0040L);
    }
    if(strcmp(cmd,"boote2")==0){/* prepare elf boot code for mips2 */
      ulong code;
      /*
	bfc00000 3c01f040 : lui r1,0xf040
	bfc00004 40816000 : mtc0        r1,C0_SR
	bfc00008 3c010100 : lui r1,0x0100
	bfc0000c 44c1f800 : ctc1        r1,C1_FCSR
	bfcxxxxx 3c1c0000 : lui r28,0
	bfcxxxxx 379c0000 : ori r29,r28,0
	bfc00010 3c190040 : lui r25,0x0040
	bfc00014 373950d0 : ori r25,r25,0x50d0
	bfc00018 0320f809 : jalr        r31,r25
	bfc0001c 00000000 : nop
      */
      put_pword(0x1fc00000L, 0x3c01f040L);
      put_pword(0x1fc00004L, 0x40816000L);
      put_pword(0x1fc00008L, 0x3c010100L);
      put_pword(0x1fc0000cL, 0x44c1f800L);
      code = 0x3c1c0000L | ((globl_ptr>>16)&0xffff);
      put_pword(0x1fc00010L, code);
      code = 0x379c0000L | ((globl_ptr)&0xffff);
      put_pword(0x1fc00014L, code);
      code = 0x3c190000L | ((elf_entry>>16)&0xffff);
      put_pword(0x1fc00018L, code);
      code = 0x37390000L | (elf_entry&0xffff);
      put_pword(0x1fc0001cL, code);
      put_pword(0x1fc00020L, 0x0320f809L);
      put_pword(0x1fc00024L, 0x00000000L);
      /*
	bfc00200 40802800 : mtc0        r0,C0_PageMask
	bfc00204 401a4000 : mfc0        r26,C0_BadVAddr
	bfc00208 241be000 : addiu       r27,r0,-0x2000
	bfc0020c 035bd024 : and r26,r26,r27
	bfc00210 001ad182 : srl r26,r26,6
	bfc00214 375a001f : ori r26,r26,0x001f
	bfc00218 409a1000 : mtc0        r26,C0_EntryLo0
	bfc0021c 275a0040 : addiu       r26,r26,0x0040
	bfc00220 409a1800 : mtc0        r26,C0_EntryLo1
	bfc00224 42000006 : tlbwr
	bfc00228 42000018 : eret
	bfc0022c 00000000 : nop
      */
      put_pword(0x1fc00200L, 0x40802800L);
      put_pword(0x1fc00204L, 0x401a4000L);
      put_pword(0x1fc00208L, 0x241be000L);
      put_pword(0x1fc0020cL, 0x035bd024L);
      put_pword(0x1fc00210L, 0x001ad182L);
      put_pword(0x1fc00214L, 0x375a001fL);
      put_pword(0x1fc00218L, 0x409a1000L);
      put_pword(0x1fc0021cL, 0x275a0040L);
      put_pword(0x1fc00220L, 0x409a1800L);
      put_pword(0x1fc00224L, 0x42000006L);
      put_pword(0x1fc00228L, 0x42000018L);
      put_pword(0x1fc0022cL, 0x00000000L);
      /*
bfc00380 401a7000 : mfc0        r26,C0_EPC
bfc00384 275a0004 : addiu       r26,r26,0x0004
bfc00388 409a7000 : mtc0        r26,C0_EPC
bfc0038c 8f5afffc : lw  r26,-4(r26)
bfc00390 335bffff : andi        r27,r26,0xffff
bfc00394 3b7b0034 : xori        r27,r27,0x0034
bfc00398 1760000b : bne r27,r0,0xbfc003c8
bfc0039c 001adc02 : srl r27,r26,16
bfc003a0 13600006 : beq r27,r0,0xbfc003bc
bfc003a4 3b7b0021 : xori        r27,r27,0x0021
bfc003a8 17600007 : bne r27,r0,0xbfc003c8
bfc003ac 3c1aaf01 : lui r26,0xaf01
bfc003b0 375a0000 : ori r26,r26,0x0000
bfc003b4 83420000 : lb  r2,0(r26)
bfc003b8 42000018 : eret
bfc003bc 3c1aaf01 : lui r26,0xaf01
bfc003c0 a3420000 : sb  r2,0(r26)
bfc003c4 42000018 : eret
bfc003c8 03ffffcd : break       1048575
bfc003cc 00000000 : nop
      */
      put_pword(0x1fc00380L, 0x401a7000L);
      put_pword(0x1fc00384L, 0x275a0004L);
      put_pword(0x1fc00388L, 0x409a7000L);
      put_pword(0x1fc0038cL, 0x8f5afffcL);
      put_pword(0x1fc00390L, 0x335bffffL);
      put_pword(0x1fc00394L, 0x3b7b0034L);
      put_pword(0x1fc00398L, 0x1760000bL);
      put_pword(0x1fc0039cL, 0x001adc02L);
      put_pword(0x1fc003a0L, 0x13600006L);
      put_pword(0x1fc003a4L, 0x3b7b0021L);
      put_pword(0x1fc003a8L, 0x17600007L);
      put_pword(0x1fc003acL, 0x3c1aaf01L);
      put_pword(0x1fc003b0L, 0x375a0020L);
      put_pword(0x1fc003b4L, 0x83420000L);
      put_pword(0x1fc003b8L, 0x42000018L);
      put_pword(0x1fc003bcL, 0x3c1aaf01L);
      put_pword(0x1fc003c0L, 0xa3420000L);
      put_pword(0x1fc003c4L, 0x42000018L);
      put_pword(0x1fc003c8L, 0x03ffffcdL);
    }
    if(strcmp(cmd,"boote3")==0){/* prepare elf boot code for mips3 */
      ulong code;
      /*
	bfc00000 3c01f040 : lui r1,0xf440
	bfc00004 40816000 : mtc0        r1,C0_SR
	bfc00008 3c010100 : lui r1,0x0100
	bfc0000c 44c1f800 : ctc1        r1,C1_FCSR
	bfc00010 3c190040 : lui r25,0x0040
	bfc00014 373950d0 : ori r25,r25,0x50d0
	bfc00018 0320f809 : jalr        r31,r25
	bfc0001c 00000000 : nop
      */
      put_pword(0x1fc00000L, 0x3c01f440L);
      put_pword(0x1fc00004L, 0x40816000L);
      put_pword(0x1fc00008L, 0x3c010100L);
      put_pword(0x1fc0000cL, 0x44c1f800L);
      code = 0x3c1c0000L | ((globl_ptr>>16)&0xffff);
      put_pword(0x1fc00010L, code);
      code = 0x379c0000L | ((globl_ptr)&0xffff);
      put_pword(0x1fc00014L, code);
      code = 0x3c190000L | ((elf_entry>>16)&0xffff);
      put_pword(0x1fc00018L, code);
      code = 0x37390000L | (elf_entry&0xffff);
      put_pword(0x1fc0001cL, code);
      put_pword(0x1fc00020L, 0x0320f809L);
      put_pword(0x1fc00024L, 0x00000000L);
      /*
	bfc00200 40802800 : mtc0        r0,C0_PageMask
	bfc00204 401a4000 : mfc0        r26,C0_BadVAddr
	bfc00208 241be000 : addiu       r27,r0,-0x2000
	bfc0020c 035bd024 : and r26,r26,r27
	bfc00210 001ad182 : srl r26,r26,6
	bfc00214 375a001f : ori r26,r26,0x001f
	bfc00218 409a1000 : mtc0        r26,C0_EntryLo0
	bfc0021c 275a0040 : addiu       r26,r26,0x0040
	bfc00220 409a1800 : mtc0        r26,C0_EntryLo1
	bfc00224 42000006 : tlbwr
	bfc00228 42000018 : eret
	bfc0022c 00000000 : nop
      */
      put_pword(0x1fc00200L, 0x40802800L);
      put_pword(0x1fc00204L, 0x401a4000L);
      put_pword(0x1fc00208L, 0x241be000L);
      put_pword(0x1fc0020cL, 0x035bd024L);
      put_pword(0x1fc00210L, 0x001ad182L);
      put_pword(0x1fc00214L, 0x375a001fL);
      put_pword(0x1fc00218L, 0x409a1000L);
      put_pword(0x1fc0021cL, 0x275a0040L);
      put_pword(0x1fc00220L, 0x409a1800L);
      put_pword(0x1fc00224L, 0x42000006L);
      put_pword(0x1fc00228L, 0x42000018L);
      put_pword(0x1fc0022cL, 0x00000000L);
      /*
bfc00380 401a7000 : mfc0        r26,C0_EPC
bfc00384 275a0004 : addiu       r26,r26,0x0004
bfc00388 409a7000 : mtc0        r26,C0_EPC
bfc0038c 8f5afffc : lw  r26,-4(r26)
bfc00390 335bffff : andi        r27,r26,0xffff
bfc00394 3b7b0034 : xori        r27,r27,0x0034
bfc00398 1760000b : bne r27,r0,0xbfc003c8
bfc0039c 001adc02 : srl r27,r26,16
bfc003a0 13600006 : beq r27,r0,0xbfc003bc
bfc003a4 3b7b0021 : xori        r27,r27,0x0021
bfc003a8 17600007 : bne r27,r0,0xbfc003c8
bfc003ac 3c1aaf01 : lui r26,0xaf01
bfc003b0 375a0000 : ori r26,r26,0x0000
bfc003b4 83420000 : lb  r2,0(r26)
bfc003b8 42000018 : eret
bfc003bc 3c1aaf01 : lui r26,0xaf01
bfc003c0 a3420000 : sb  r2,0(r26)
bfc003c4 42000018 : eret
bfc003c8 401b6800 : mfc0        r27,C0_Cause
bfc003cc 337b00ff : andi        r27,r27,0x00ff
bfc003d0 3b7b0010 : xori        r27,r27,0x0010
bfc003d4 17600012 : bne r27,r0,0xbfc00420
bfc003d8 001ade82 : srl r27,r26,26
bfc003dc 3b7b0037 : xori        r27,r27,0x0037
bfc003e0 1760000f : bne r27,r0,0xbfc00420
bfc003e4 001ad180 : sll r26,r26,6
bfc003e8 001ad182 : srl r26,r26,6
bfc003ec 341b0023 : ori r27,r0,0x0023
bfc003f0 001bde80 : sll r27,r27,26
bfc003f4 035bd025 : or  r26,r26,r27
bfc003f8 3c1bbfc0 : lui r27,0xbfc0
bfc003fc 377b0414 : ori r27,r27,0x0414
bfc00400 af7a0000 : sw  r26,0(r27)
bfc00404 bf750000 : cache       Hit_Writeback_Inv_D,0(r27)
bfc00408 bf700000 : cache       Hit_Inv_I,0(r27)
bfc0040c 03600008 : jr  r27
bfc00410 00000000 : nop
bfc00414 00000000 : nop
bfc00418 42000018 : eret
bfc0041c 00000000 : nop
bfc00420 03ffffcd : break       1048575
bfc00424 00000000 : nop
      */
      put_pword(0x1fc00380L, 0x401a7000L);
      put_pword(0x1fc00384L, 0x275a0004L);
      put_pword(0x1fc00388L, 0x409a7000L);
      put_pword(0x1fc0038cL, 0x8f5afffcL);
      put_pword(0x1fc00390L, 0x335bffffL);
      put_pword(0x1fc00394L, 0x3b7b0034L);
      put_pword(0x1fc00398L, 0x1760000bL);
      put_pword(0x1fc0039cL, 0x001adc02L);
      put_pword(0x1fc003a0L, 0x13600006L);
      put_pword(0x1fc003a4L, 0x3b7b0021L);
      put_pword(0x1fc003a8L, 0x17600007L);
      put_pword(0x1fc003acL, 0x3c1aaf01L);
      put_pword(0x1fc003b0L, 0x375a0020L);
      put_pword(0x1fc003b4L, 0x83420000L);
      put_pword(0x1fc003b8L, 0x42000018L);
      put_pword(0x1fc003bcL, 0x3c1aaf01L);
      put_pword(0x1fc003c0L, 0xa3420000L);
      put_pword(0x1fc003c4L, 0x42000018L);
      put_pword(0x1fc003c8L, 0x401b6800L);
      put_pword(0x1fc003ccL, 0x337b00ffL);
      put_pword(0x1fc003d0L, 0x3b7b0010L);
      put_pword(0x1fc003d4L, 0x17600012L);
      put_pword(0x1fc003d8L, 0x001ade82L);
      put_pword(0x1fc003dcL, 0x3b7b0037L);
      put_pword(0x1fc003e0L, 0x1760000fL);
      put_pword(0x1fc003e4L, 0x001ad180L);
      put_pword(0x1fc003e8L, 0x001ad182L);
      put_pword(0x1fc003ecL, 0x341b0023L);
      put_pword(0x1fc003f0L, 0x001bde80L);
      put_pword(0x1fc003f4L, 0x035bd025L);
      put_pword(0x1fc003f8L, 0x3c1bbfc0L);
      put_pword(0x1fc003fcL, 0x377b0414L);
      put_pword(0x1fc00400L, 0xaf7a0000L);
      put_pword(0x1fc00404L, 0xbf750000L);
      put_pword(0x1fc00408L, 0xbf700000L);
      put_pword(0x1fc0040cL, 0x03600008L);
      put_pword(0x1fc00410L, 0x00000000L);
      put_pword(0x1fc00414L, 0x00000000L);
      put_pword(0x1fc00418L, 0x42000018L);
      put_pword(0x1fc0041cL, 0x00000000L);
      put_pword(0x1fc00420L, 0x03ffffcdL);
    }
    if(strcmp(cmd,"reset")==0){/* reset */
      set_pc(0xffffffffL, 0xbfc00000L);
      init_cpu();
      init_cpu16();
      init_cp0();
      init_cache();
      bt_init();
      io_init();
      trace_num = 0L;
    }
    if(strcmp(cmd,"t")==0){/* trace */
      ulong addr1,addr0;
      int  i;
      long n;
      if(ac==1){
        if(disp_inst){
          get_pc(&addr1,&addr0);
          printf("(%d) ", trace_num);
          if(addr0&1L)
            dis16_one(addr1, addr0^1L);
          else
            dis_one(addr1, addr0);
        }
        execute();
        if(disp_cpu)
          cpu_dump();
        if(disp_fpu)
          fpu_dump();
        if(disp_cp0)
          cp0_dump();
        if(disp_cpu||disp_fpu||disp_cp0)
          printf("-----------------------------\n");
	trace_num++;
      }
      else{
        if(strcmp(av1,"inf")){
	  n = gen_val(av1);
	  for(i=0;(i<n)&&(sig_stop==0);i++){
            if(disp_inst){
              get_pc(&addr1,&addr0);
              printf("(%d) ", trace_num);
              if(addr0&1L)
                dis16_one(addr1, addr0^1L);
              else
                dis_one(addr1, addr0);
            }
            execute();
            if(disp_cpu)
              cpu_dump();
            if(disp_fpu)
              fpu_dump();
            if(disp_cp0)
              cp0_dump();
            if(disp_cpu||disp_fpu||disp_cp0)
              printf("-----------------------------\n");
	    trace_num++;
	    if(break_cond())
	      break;
	  }
        }
      else{
	  for(i=0;sig_stop==0;i++){
            if(disp_inst){
              get_pc(&addr1,&addr0);
              printf("(%d) ", trace_num);
              if(addr0&1L)
                dis16_one(addr1, addr0^1L);
              else
                dis_one(addr1, addr0);
            }
            execute();
            if(disp_cpu)
              cpu_dump();
            if(disp_fpu)
              fpu_dump();
            if(disp_cp0)
              cp0_dump();
            if(disp_cpu||disp_fpu||disp_cp0)
              printf("-----------------------------\n");
	    trace_num++;
	    if(break_cond())
	      break;
	  }
        }
      }
    }
    if(strcmp(cmd,"disp")==0){/* display */
      if((ac==1)||(strcmp(av1,"all")==0)){
        disp_inst = 1;
        disp_cpu  = 1;
        disp_fpu  = 1;
        disp_cp0  = 1;
      }
      if(strcmp(av1,"inst")==0){
        disp_inst = 1;
      }
      if(strcmp(av1,"cpu")==0){
        disp_cpu = 1;
      }
      if(strcmp(av1,"cp0")==0){
        disp_cp0 = 1;
      }
      if(strcmp(av1,"fpu")==0){
        disp_fpu = 1;
      }
      if(strcmp(av1,"cp1")==0){
        disp_fpu = 1;
      }
    }
    if(strcmp(cmd,"nodisp")==0){/* no display */
      if((ac==1)||(strcmp(av1,"all")==0)){
        disp_inst = 0;
        disp_cpu  = 0;
        disp_fpu  = 0;
        disp_cp0  = 0;
      }
      if(strcmp(av1,"inst")==0){
        disp_inst = 0;
      }
      if(strcmp(av1,"cpu")==0){
        disp_cpu = 0;
      }
      if(strcmp(av1,"cp0")==0){
        disp_cp0 = 0;
      }
      if(strcmp(av1,"fpu")==0){
        disp_fpu = 0;
      }
      if(strcmp(av1,"cp1")==0){
        disp_fpu = 0;
      }
    }
    if(strcmp(cmd,"set")==0){/* cpu register set */
      int no;
      long hi,lo;
      if(ac==3){
        lo = gen_val(av2);
        hi = (lo & 0x80000000L)? 0xffffffff : 0;
        if(strcmp(av1,"hi")==0){
          set_hi((ulong)hi, (ulong)lo);
        } else if(strcmp(av1,"lo")==0){
          set_lo((ulong)hi, (ulong)lo);
        } else {
          no = regnum(av1);
          if(no==0x1000)/* PC */
            set_pc((ulong)hi, (ulong)lo);
          else
            set_gr(no, (ulong)hi, (ulong)lo);
        }
      }
      if(ac==4){
        hi = gen_val(av2);
        lo = gen_val(av3);
        if(strcmp(av1,"hi")==0){
          set_hi((ulong)hi, (ulong)lo);
        } else if(strcmp(av1,"lo")==0){
          set_lo((ulong)hi, (ulong)lo);
        } else {
          no = regnum(av1);
          if(no==0x1000)/* PC */
            set_pc((ulong)hi, (ulong)lo);
          else
            set_gr(no, (ulong)hi, (ulong)lo);
        }
      }
    }
    if(strcmp(cmd,"fset")==0){/* fpu register set */
      int no;
      long hi,lo;
      if(ac==3){
        lo = gen_val(av2);
        hi = (lo & 0x80000000L)? 0xffffffff : 0;
        no = regnum(av1);
        set_fr64(no, (ulong)hi, (ulong)lo);
      }
      if(ac==4){
        hi = gen_val(av2);
        lo = gen_val(av3);
        no = regnum(av1);
        set_fr64(no, (ulong)hi, (ulong)lo);
      }
    }
    if(strcmp(cmd,"fcset")==0){/* fpu register set */
      long lo;
      if(ac==2){
        lo = gen_val(av1);
        set_fcr31((ulong)lo);
      }
    }
    if(strcmp(cmd,"cset")==0){/* cp0 register set */
      int no;
      long hi,lo;
      if(ac==3){
        lo = gen_val(av2);
        no = regnum(av1);
        mtc0(no, (ulong)lo);
      }
      if(ac==4){
        hi = gen_val(av2);
        lo = gen_val(av3);
        no = regnum(av1);
        dmtc0(no, (ulong)hi, (ulong)lo);
      }
    }
    if(strcmp(cmd,"rep")==0){/* report */
      if(strcmp(av1,"branch")==0){
	bt_report();
      }
      if(strcmp(av1,"cache")==0){
	ic_report();
	dc_report();
      }
    }
    if(strcmp(cmd,"bt")==0){/* report */
      set_bt(gen_val(av1)%513);
    }
    if(strcmp(cmd,"mips32")==0){/* mips32 switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	mips32_en = 1;
      }
      if(strcmp(av1,"off")==0){
	mips32_en = 0;
      }
    }
    if(strcmp(cmd,"fpu")==0){/* fpu switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	fpu_en = 1;
      }
      if(strcmp(av1,"off")==0){
	fpu_en = 0;
      }
    }
    if(strcmp(cmd,"ps")==0){/* fpu switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	ps_en = 1;
	fpu_en = 1;
	no_mips4 = 0;
      }
      if(strcmp(av1,"off")==0){
	ps_en = 0;
      }
    }
    if(strcmp(cmd,"mips3d")==0){/* fpu switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	m3d_en = 1;
      }
      if(strcmp(av1,"off")==0){
	m3d_en = 0;
      }
    }
    if(strcmp(cmd,"mips4")==0){/* fpu switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	no_mips4 = 0;
      }
      if(strcmp(av1,"off")==0){
	no_mips4 = 1;
      }
    }
    if(strcmp(cmd,"llsc")==0){/* ll/sc switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	ty_llsc = 1;
      }
      if(strcmp(av1,"off")==0){
	ty_llsc = 0;
      }
    }
    if(strcmp(cmd,"orig")==0){/* original insts switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	orig_en = 1;
      }
      if(strcmp(av1,"off")==0){
	orig_en = 0;
      }
    }
    if(strcmp(cmd,"ver2")==0){/* version 2 insts switch */
      if((ac==1)||(strcmp(av1,"on")==0)){
	ver2_en = 1;
      }
      if(strcmp(av1,"off")==0){
	ver2_en = 0;
      }
    }
    if(strcmp(cmd,"cpu")==0){/* cpu switch */
      if(ac==1){
	printf("cpu is %s\n", (ty_cpu==R4100)? "r4100" : "r4300");
      }
      else{
	if(strcmp(av1,"r4100")==0){
	  ty_cpu = R4100;
	}
	if(strcmp(av1,"r4300")==0){
	  ty_cpu = R4300;
	}
      }
    }
    if(strcmp(cmd,"a")==0){/* assemble */
      asmips(av1, stdin);
    }
    if(strcmp(cmd,"a16")==0){/* assemble (mips16)*/
      asmips16(av1, stdin);
    }
    if(strcmp(cmd,"u")==0){/* disassemble */
      dismips(av1,av2);
    }
    if(strcmp(cmd,"u16")==0){/* disassemble (mips16)*/
      dismips16(av1,av2);
    }
    if(strcmp(cmd,"li")==0){/* load intel hex */
      loadi(av1,av2);
    }
    if(strcmp(cmd,"ls")==0){/* load s-format hex */
      loads(av1,av2);
    }
    if(strcmp(cmd,"lm")==0){/* load mem image */
      loadm(av1);
    }
    if(strcmp(cmd,"le")==0){/* load elf image */
      loade(av1);
    }
    if(strcmp(cmd,"la")==0){/* load and assemble */
      fp = fopen(av1, "r");
      if(fp==NULL){
        printf("cannot open %s\n", av1);
      }
      else{
        asmips("", fp);
        fclose(fp);
		printf("\n");
      }
    }
    if(strcmp(cmd,"la16")==0){/* load and assemble */
      fp = fopen(av1, "r");
      if(fp==NULL){
        printf("cannot open %s\n", av1);
      }
      else{
        asmips16("", fp);
        fclose(fp);
	printf("\n");
      }
    }
    if(strcmp(cmd,"r")==0){/* register dump */
      if((ac==1)||(strcmp(av1,"cpu")==0))
	cpu_dump();
      if(strcmp(av1,"cp0")==0)
	cp0_dump();
      if((strcmp(av1,"fpu")==0)||(strcmp(av1,"cp1")==0))
	fpu_dump();
    }
    if(strcmp(cmd,"bi0")==0){/* instruction break 0 */
      if(ac==1)
	bp_inst0_v ^= 1;
      else{
	bp_inst0 = gen_val(av1);
	strcpy(bp_inst0_msg,av2);
	bp_inst0_v = 1;
      }
    }
    if(strcmp(cmd,"bi1")==0){/* instruction break 1 */
      if(ac==1)
	bp_inst1_v ^= 1;
      else{
	bp_inst1 = gen_val(av1);
	strcpy(bp_inst1_msg,av2);
	bp_inst1_v = 1;
      }
    }
    if(strcmp(cmd,"ba")==0){/* address break 0 */
      if(ac==1)
	bp_a_v ^= 1;
      else {
	bp_a = gen_val(av1);
	strcpy(bp_a_msg,av2);
	bp_a_v = 1;
      }
    }
    if(strcmp(cmd,"m")==0){/* memory change */
      if(ac==3){
	put_pword(gen_val(av1), gen_val(av2));
      }
    }
    if(strcmp(cmd,"dw")==0){/* memory dump word */
      if(ac==3){
	da0 = gen_val(av1);
	da1 = gen_val(av2);
	mem_dump(da0, da1, 2);
      }
      if(ac==2){
	da0 = gen_val(av1);
	da1 = da0+0x80;
	mem_dump(da0, da1, 2);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 2);
      }
    }
    if(strcmp(cmd,"dh")==0){/* memory dump halfword */
      if(ac==3){
	da0 = gen_val(av1);
	da1 = gen_val(av2);
	mem_dump(da0, da1, 1);
      }
      if(ac==2){
	da0 = gen_val(av1);
	da1 = da0+0x80;
	mem_dump(da0, da1, 1);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 1);
      }
    }
    if(strcmp(cmd,"db")==0){/* memory dump byte */
      if(ac==3){
	da0 = gen_val(av1);
	da1 = gen_val(av2);
	mem_dump(da0, da1, 0);
      }
      if(ac==2){
	da0 = gen_val(av1);
	da1 = da0+0x80;
	mem_dump(da0, da1, 0);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 0);
      }
    }
    if(cmd[0]=='#'){/* comment */
    }
    if(strcmp(cmd,"mem_init")==0){/* memory initialize */
      mem_init();
    }
    if(strcmp(cmd,"h")==0){/* help */
      help();
    }
  }
  exit(0);
}
